// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class ContratoStruct extends BaseStruct {
  ContratoStruct({
    int? idContrato,
    String? dsLatitude,
    String? dsLongitude,
    String? nmLogradouroCompleto,
    String? nrLogradouro,
    String? dsQuadra,
    String? dsLote,
    String? nmDistrito,
    String? nmBairro,
    String? nmCidade,
    String? sgEstado,
    String? dsComplemento,
    String? dsPontoReferencia,
    String? cdCep,
    int? idCentroCusto,
    String? cdCentroCusto,
    String? nmCentroCusto,
    String? nmPessoa,
    String? nmCobertura,
    String? cdStatus,
    bool? flAtivo,
    String? dtUltPagamento,
    String? vrAjusteSaldo,
  })  : _idContrato = idContrato,
        _dsLatitude = dsLatitude,
        _dsLongitude = dsLongitude,
        _nmLogradouroCompleto = nmLogradouroCompleto,
        _nrLogradouro = nrLogradouro,
        _dsQuadra = dsQuadra,
        _dsLote = dsLote,
        _nmDistrito = nmDistrito,
        _nmBairro = nmBairro,
        _nmCidade = nmCidade,
        _sgEstado = sgEstado,
        _dsComplemento = dsComplemento,
        _dsPontoReferencia = dsPontoReferencia,
        _cdCep = cdCep,
        _idCentroCusto = idCentroCusto,
        _cdCentroCusto = cdCentroCusto,
        _nmCentroCusto = nmCentroCusto,
        _nmPessoa = nmPessoa,
        _nmCobertura = nmCobertura,
        _cdStatus = cdStatus,
        _flAtivo = flAtivo,
        _dtUltPagamento = dtUltPagamento,
        _vrAjusteSaldo = vrAjusteSaldo;

  // "idContrato" field.
  int? _idContrato;
  int get idContrato => _idContrato ?? 0;
  set idContrato(int? val) => _idContrato = val;

  void incrementIdContrato(int amount) => idContrato = idContrato + amount;

  bool hasIdContrato() => _idContrato != null;

  // "dsLatitude" field.
  String? _dsLatitude;
  String get dsLatitude => _dsLatitude ?? '';
  set dsLatitude(String? val) => _dsLatitude = val;

  bool hasDsLatitude() => _dsLatitude != null;

  // "dsLongitude" field.
  String? _dsLongitude;
  String get dsLongitude => _dsLongitude ?? '';
  set dsLongitude(String? val) => _dsLongitude = val;

  bool hasDsLongitude() => _dsLongitude != null;

  // "nmLogradouroCompleto" field.
  String? _nmLogradouroCompleto;
  String get nmLogradouroCompleto => _nmLogradouroCompleto ?? '';
  set nmLogradouroCompleto(String? val) => _nmLogradouroCompleto = val;

  bool hasNmLogradouroCompleto() => _nmLogradouroCompleto != null;

  // "nrLogradouro" field.
  String? _nrLogradouro;
  String get nrLogradouro => _nrLogradouro ?? '';
  set nrLogradouro(String? val) => _nrLogradouro = val;

  bool hasNrLogradouro() => _nrLogradouro != null;

  // "dsQuadra" field.
  String? _dsQuadra;
  String get dsQuadra => _dsQuadra ?? '';
  set dsQuadra(String? val) => _dsQuadra = val;

  bool hasDsQuadra() => _dsQuadra != null;

  // "dsLote" field.
  String? _dsLote;
  String get dsLote => _dsLote ?? '';
  set dsLote(String? val) => _dsLote = val;

  bool hasDsLote() => _dsLote != null;

  // "nmDistrito" field.
  String? _nmDistrito;
  String get nmDistrito => _nmDistrito ?? '';
  set nmDistrito(String? val) => _nmDistrito = val;

  bool hasNmDistrito() => _nmDistrito != null;

  // "nmBairro" field.
  String? _nmBairro;
  String get nmBairro => _nmBairro ?? '';
  set nmBairro(String? val) => _nmBairro = val;

  bool hasNmBairro() => _nmBairro != null;

  // "nmCidade" field.
  String? _nmCidade;
  String get nmCidade => _nmCidade ?? '';
  set nmCidade(String? val) => _nmCidade = val;

  bool hasNmCidade() => _nmCidade != null;

  // "sgEstado" field.
  String? _sgEstado;
  String get sgEstado => _sgEstado ?? '';
  set sgEstado(String? val) => _sgEstado = val;

  bool hasSgEstado() => _sgEstado != null;

  // "dsComplemento" field.
  String? _dsComplemento;
  String get dsComplemento => _dsComplemento ?? '';
  set dsComplemento(String? val) => _dsComplemento = val;

  bool hasDsComplemento() => _dsComplemento != null;

  // "dsPontoReferencia" field.
  String? _dsPontoReferencia;
  String get dsPontoReferencia => _dsPontoReferencia ?? '';
  set dsPontoReferencia(String? val) => _dsPontoReferencia = val;

  bool hasDsPontoReferencia() => _dsPontoReferencia != null;

  // "cdCep" field.
  String? _cdCep;
  String get cdCep => _cdCep ?? '';
  set cdCep(String? val) => _cdCep = val;

  bool hasCdCep() => _cdCep != null;

  // "idCentroCusto" field.
  int? _idCentroCusto;
  int get idCentroCusto => _idCentroCusto ?? 0;
  set idCentroCusto(int? val) => _idCentroCusto = val;

  void incrementIdCentroCusto(int amount) =>
      idCentroCusto = idCentroCusto + amount;

  bool hasIdCentroCusto() => _idCentroCusto != null;

  // "cdCentroCusto" field.
  String? _cdCentroCusto;
  String get cdCentroCusto => _cdCentroCusto ?? '';
  set cdCentroCusto(String? val) => _cdCentroCusto = val;

  bool hasCdCentroCusto() => _cdCentroCusto != null;

  // "nmCentroCusto" field.
  String? _nmCentroCusto;
  String get nmCentroCusto => _nmCentroCusto ?? '';
  set nmCentroCusto(String? val) => _nmCentroCusto = val;

  bool hasNmCentroCusto() => _nmCentroCusto != null;

  // "nmPessoa" field.
  String? _nmPessoa;
  String get nmPessoa => _nmPessoa ?? '';
  set nmPessoa(String? val) => _nmPessoa = val;

  bool hasNmPessoa() => _nmPessoa != null;

  // "nmCobertura" field.
  String? _nmCobertura;
  String get nmCobertura => _nmCobertura ?? '';
  set nmCobertura(String? val) => _nmCobertura = val;

  bool hasNmCobertura() => _nmCobertura != null;

  // "cdStatus" field.
  String? _cdStatus;
  String get cdStatus => _cdStatus ?? '';
  set cdStatus(String? val) => _cdStatus = val;

  bool hasCdStatus() => _cdStatus != null;

  // "flAtivo" field.
  bool? _flAtivo;
  bool get flAtivo => _flAtivo ?? false;
  set flAtivo(bool? val) => _flAtivo = val;

  bool hasFlAtivo() => _flAtivo != null;

  // "dtUltPagamento" field.
  String? _dtUltPagamento;
  String get dtUltPagamento => _dtUltPagamento ?? '';
  set dtUltPagamento(String? val) => _dtUltPagamento = val;

  bool hasDtUltPagamento() => _dtUltPagamento != null;

  // "vrAjusteSaldo" field.
  String? _vrAjusteSaldo;
  String get vrAjusteSaldo => _vrAjusteSaldo ?? '';
  set vrAjusteSaldo(String? val) => _vrAjusteSaldo = val;

  bool hasVrAjusteSaldo() => _vrAjusteSaldo != null;

  static ContratoStruct fromMap(Map<String, dynamic> data) => ContratoStruct(
        idContrato: castToType<int>(data['idContrato']),
        dsLatitude: data['dsLatitude'] as String?,
        dsLongitude: data['dsLongitude'] as String?,
        nmLogradouroCompleto: data['nmLogradouroCompleto'] as String?,
        nrLogradouro: data['nrLogradouro'] as String?,
        dsQuadra: data['dsQuadra'] as String?,
        dsLote: data['dsLote'] as String?,
        nmDistrito: data['nmDistrito'] as String?,
        nmBairro: data['nmBairro'] as String?,
        nmCidade: data['nmCidade'] as String?,
        sgEstado: data['sgEstado'] as String?,
        dsComplemento: data['dsComplemento'] as String?,
        dsPontoReferencia: data['dsPontoReferencia'] as String?,
        cdCep: data['cdCep'] as String?,
        idCentroCusto: castToType<int>(data['idCentroCusto']),
        cdCentroCusto: data['cdCentroCusto'] as String?,
        nmCentroCusto: data['nmCentroCusto'] as String?,
        nmPessoa: data['nmPessoa'] as String?,
        nmCobertura: data['nmCobertura'] as String?,
        cdStatus: data['cdStatus'] as String?,
        flAtivo: data['flAtivo'] as bool?,
        dtUltPagamento: data['dtUltPagamento'] as String?,
        vrAjusteSaldo: data['vrAjusteSaldo'] as String?,
      );

  static ContratoStruct? maybeFromMap(dynamic data) =>
      data is Map ? ContratoStruct.fromMap(data.cast<String, dynamic>()) : null;

  Map<String, dynamic> toMap() => {
        'idContrato': _idContrato,
        'dsLatitude': _dsLatitude,
        'dsLongitude': _dsLongitude,
        'nmLogradouroCompleto': _nmLogradouroCompleto,
        'nrLogradouro': _nrLogradouro,
        'dsQuadra': _dsQuadra,
        'dsLote': _dsLote,
        'nmDistrito': _nmDistrito,
        'nmBairro': _nmBairro,
        'nmCidade': _nmCidade,
        'sgEstado': _sgEstado,
        'dsComplemento': _dsComplemento,
        'dsPontoReferencia': _dsPontoReferencia,
        'cdCep': _cdCep,
        'idCentroCusto': _idCentroCusto,
        'cdCentroCusto': _cdCentroCusto,
        'nmCentroCusto': _nmCentroCusto,
        'nmPessoa': _nmPessoa,
        'nmCobertura': _nmCobertura,
        'cdStatus': _cdStatus,
        'flAtivo': _flAtivo,
        'dtUltPagamento': _dtUltPagamento,
        'vrAjusteSaldo': _vrAjusteSaldo,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'idContrato': serializeParam(
          _idContrato,
          ParamType.int,
        ),
        'dsLatitude': serializeParam(
          _dsLatitude,
          ParamType.String,
        ),
        'dsLongitude': serializeParam(
          _dsLongitude,
          ParamType.String,
        ),
        'nmLogradouroCompleto': serializeParam(
          _nmLogradouroCompleto,
          ParamType.String,
        ),
        'nrLogradouro': serializeParam(
          _nrLogradouro,
          ParamType.String,
        ),
        'dsQuadra': serializeParam(
          _dsQuadra,
          ParamType.String,
        ),
        'dsLote': serializeParam(
          _dsLote,
          ParamType.String,
        ),
        'nmDistrito': serializeParam(
          _nmDistrito,
          ParamType.String,
        ),
        'nmBairro': serializeParam(
          _nmBairro,
          ParamType.String,
        ),
        'nmCidade': serializeParam(
          _nmCidade,
          ParamType.String,
        ),
        'sgEstado': serializeParam(
          _sgEstado,
          ParamType.String,
        ),
        'dsComplemento': serializeParam(
          _dsComplemento,
          ParamType.String,
        ),
        'dsPontoReferencia': serializeParam(
          _dsPontoReferencia,
          ParamType.String,
        ),
        'cdCep': serializeParam(
          _cdCep,
          ParamType.String,
        ),
        'idCentroCusto': serializeParam(
          _idCentroCusto,
          ParamType.int,
        ),
        'cdCentroCusto': serializeParam(
          _cdCentroCusto,
          ParamType.String,
        ),
        'nmCentroCusto': serializeParam(
          _nmCentroCusto,
          ParamType.String,
        ),
        'nmPessoa': serializeParam(
          _nmPessoa,
          ParamType.String,
        ),
        'nmCobertura': serializeParam(
          _nmCobertura,
          ParamType.String,
        ),
        'cdStatus': serializeParam(
          _cdStatus,
          ParamType.String,
        ),
        'flAtivo': serializeParam(
          _flAtivo,
          ParamType.bool,
        ),
        'dtUltPagamento': serializeParam(
          _dtUltPagamento,
          ParamType.String,
        ),
        'vrAjusteSaldo': serializeParam(
          _vrAjusteSaldo,
          ParamType.String,
        ),
      }.withoutNulls;

  static ContratoStruct fromSerializableMap(Map<String, dynamic> data) =>
      ContratoStruct(
        idContrato: deserializeParam(
          data['idContrato'],
          ParamType.int,
          false,
        ),
        dsLatitude: deserializeParam(
          data['dsLatitude'],
          ParamType.String,
          false,
        ),
        dsLongitude: deserializeParam(
          data['dsLongitude'],
          ParamType.String,
          false,
        ),
        nmLogradouroCompleto: deserializeParam(
          data['nmLogradouroCompleto'],
          ParamType.String,
          false,
        ),
        nrLogradouro: deserializeParam(
          data['nrLogradouro'],
          ParamType.String,
          false,
        ),
        dsQuadra: deserializeParam(
          data['dsQuadra'],
          ParamType.String,
          false,
        ),
        dsLote: deserializeParam(
          data['dsLote'],
          ParamType.String,
          false,
        ),
        nmDistrito: deserializeParam(
          data['nmDistrito'],
          ParamType.String,
          false,
        ),
        nmBairro: deserializeParam(
          data['nmBairro'],
          ParamType.String,
          false,
        ),
        nmCidade: deserializeParam(
          data['nmCidade'],
          ParamType.String,
          false,
        ),
        sgEstado: deserializeParam(
          data['sgEstado'],
          ParamType.String,
          false,
        ),
        dsComplemento: deserializeParam(
          data['dsComplemento'],
          ParamType.String,
          false,
        ),
        dsPontoReferencia: deserializeParam(
          data['dsPontoReferencia'],
          ParamType.String,
          false,
        ),
        cdCep: deserializeParam(
          data['cdCep'],
          ParamType.String,
          false,
        ),
        idCentroCusto: deserializeParam(
          data['idCentroCusto'],
          ParamType.int,
          false,
        ),
        cdCentroCusto: deserializeParam(
          data['cdCentroCusto'],
          ParamType.String,
          false,
        ),
        nmCentroCusto: deserializeParam(
          data['nmCentroCusto'],
          ParamType.String,
          false,
        ),
        nmPessoa: deserializeParam(
          data['nmPessoa'],
          ParamType.String,
          false,
        ),
        nmCobertura: deserializeParam(
          data['nmCobertura'],
          ParamType.String,
          false,
        ),
        cdStatus: deserializeParam(
          data['cdStatus'],
          ParamType.String,
          false,
        ),
        flAtivo: deserializeParam(
          data['flAtivo'],
          ParamType.bool,
          false,
        ),
        dtUltPagamento: deserializeParam(
          data['dtUltPagamento'],
          ParamType.String,
          false,
        ),
        vrAjusteSaldo: deserializeParam(
          data['vrAjusteSaldo'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'ContratoStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is ContratoStruct &&
        idContrato == other.idContrato &&
        dsLatitude == other.dsLatitude &&
        dsLongitude == other.dsLongitude &&
        nmLogradouroCompleto == other.nmLogradouroCompleto &&
        nrLogradouro == other.nrLogradouro &&
        dsQuadra == other.dsQuadra &&
        dsLote == other.dsLote &&
        nmDistrito == other.nmDistrito &&
        nmBairro == other.nmBairro &&
        nmCidade == other.nmCidade &&
        sgEstado == other.sgEstado &&
        dsComplemento == other.dsComplemento &&
        dsPontoReferencia == other.dsPontoReferencia &&
        cdCep == other.cdCep &&
        idCentroCusto == other.idCentroCusto &&
        cdCentroCusto == other.cdCentroCusto &&
        nmCentroCusto == other.nmCentroCusto &&
        nmPessoa == other.nmPessoa &&
        nmCobertura == other.nmCobertura &&
        cdStatus == other.cdStatus &&
        flAtivo == other.flAtivo &&
        dtUltPagamento == other.dtUltPagamento &&
        vrAjusteSaldo == other.vrAjusteSaldo;
  }

  @override
  int get hashCode => const ListEquality().hash([
        idContrato,
        dsLatitude,
        dsLongitude,
        nmLogradouroCompleto,
        nrLogradouro,
        dsQuadra,
        dsLote,
        nmDistrito,
        nmBairro,
        nmCidade,
        sgEstado,
        dsComplemento,
        dsPontoReferencia,
        cdCep,
        idCentroCusto,
        cdCentroCusto,
        nmCentroCusto,
        nmPessoa,
        nmCobertura,
        cdStatus,
        flAtivo,
        dtUltPagamento,
        vrAjusteSaldo
      ]);
}

ContratoStruct createContratoStruct({
  int? idContrato,
  String? dsLatitude,
  String? dsLongitude,
  String? nmLogradouroCompleto,
  String? nrLogradouro,
  String? dsQuadra,
  String? dsLote,
  String? nmDistrito,
  String? nmBairro,
  String? nmCidade,
  String? sgEstado,
  String? dsComplemento,
  String? dsPontoReferencia,
  String? cdCep,
  int? idCentroCusto,
  String? cdCentroCusto,
  String? nmCentroCusto,
  String? nmPessoa,
  String? nmCobertura,
  String? cdStatus,
  bool? flAtivo,
  String? dtUltPagamento,
  String? vrAjusteSaldo,
}) =>
    ContratoStruct(
      idContrato: idContrato,
      dsLatitude: dsLatitude,
      dsLongitude: dsLongitude,
      nmLogradouroCompleto: nmLogradouroCompleto,
      nrLogradouro: nrLogradouro,
      dsQuadra: dsQuadra,
      dsLote: dsLote,
      nmDistrito: nmDistrito,
      nmBairro: nmBairro,
      nmCidade: nmCidade,
      sgEstado: sgEstado,
      dsComplemento: dsComplemento,
      dsPontoReferencia: dsPontoReferencia,
      cdCep: cdCep,
      idCentroCusto: idCentroCusto,
      cdCentroCusto: cdCentroCusto,
      nmCentroCusto: nmCentroCusto,
      nmPessoa: nmPessoa,
      nmCobertura: nmCobertura,
      cdStatus: cdStatus,
      flAtivo: flAtivo,
      dtUltPagamento: dtUltPagamento,
      vrAjusteSaldo: vrAjusteSaldo,
    );
