// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class FaturaStruct extends BaseStruct {
  FaturaStruct({
    String? cdBarras,
    String? cdNossoNumero,
    String? cdLinhaDigitavel,
    int? idContrato,
    int? idDocumento,
    String? cdTipoCobranca,
    String? dtVencimento,
    String? dtVencimentoCodBarras,
    String? cdReferencia,
    int? idPessoa,
    int? idCliente,
    int? idDoc,
    int? idContaBoleto,
    String? nmConta,
    String? nmBeneficiario,
    bool? flContaBancaria,
    String? tpBoleto,
    String? nmUsuarioBaixou,
    String? nmUsuarioTratouRetorno,
    String? cdCentroCustoBaixou,
    String? nmCentroCustoBaixou,
    String? nmUnidadeColeta,
    String? dtPago,
    String? dtSistemaBaixa,
    String? dtCredito,
    String? dtRetornoTratado,
    int? vrAcrescimo,
    int? vrDesconto,
    int? vrMultaJustos,
    int? vrTarifa,
    int? vrParcial,
    String? carneDtVencimentoInicio,
    String? carneDtValidade,
    String? dtAgendado,
    String? nmUsuarioAgendou,
    String? dtSistemaGerado,
    String? nmUsuarioGerou,
    String? dtExcluiu,
    String? nmUsuarioExcluiu,
    String? dtDispensa,
    String? nmUsuarioDispensou,
    String? dsTipo,
    String? dsDispensa,
    String? dsObservacao,
    String? cdLinkJuno,
    int? nrBoleto,
    int? nrTtlBoletoContrato,
    bool? flPago,
    double? vrBoleto,
    int? idCarne,
    int? vrPago,
    int? vrAgendado,
    int? idAcao,
    int? idOs,
    int? idVenda,
    String? idBoleto,
    int? carneQtParcelas,
  })  : _cdBarras = cdBarras,
        _cdNossoNumero = cdNossoNumero,
        _cdLinhaDigitavel = cdLinhaDigitavel,
        _idContrato = idContrato,
        _idDocumento = idDocumento,
        _cdTipoCobranca = cdTipoCobranca,
        _dtVencimento = dtVencimento,
        _dtVencimentoCodBarras = dtVencimentoCodBarras,
        _cdReferencia = cdReferencia,
        _idPessoa = idPessoa,
        _idCliente = idCliente,
        _idDoc = idDoc,
        _idContaBoleto = idContaBoleto,
        _nmConta = nmConta,
        _nmBeneficiario = nmBeneficiario,
        _flContaBancaria = flContaBancaria,
        _tpBoleto = tpBoleto,
        _nmUsuarioBaixou = nmUsuarioBaixou,
        _nmUsuarioTratouRetorno = nmUsuarioTratouRetorno,
        _cdCentroCustoBaixou = cdCentroCustoBaixou,
        _nmCentroCustoBaixou = nmCentroCustoBaixou,
        _nmUnidadeColeta = nmUnidadeColeta,
        _dtPago = dtPago,
        _dtSistemaBaixa = dtSistemaBaixa,
        _dtCredito = dtCredito,
        _dtRetornoTratado = dtRetornoTratado,
        _vrAcrescimo = vrAcrescimo,
        _vrDesconto = vrDesconto,
        _vrMultaJustos = vrMultaJustos,
        _vrTarifa = vrTarifa,
        _vrParcial = vrParcial,
        _carneDtVencimentoInicio = carneDtVencimentoInicio,
        _carneDtValidade = carneDtValidade,
        _dtAgendado = dtAgendado,
        _nmUsuarioAgendou = nmUsuarioAgendou,
        _dtSistemaGerado = dtSistemaGerado,
        _nmUsuarioGerou = nmUsuarioGerou,
        _dtExcluiu = dtExcluiu,
        _nmUsuarioExcluiu = nmUsuarioExcluiu,
        _dtDispensa = dtDispensa,
        _nmUsuarioDispensou = nmUsuarioDispensou,
        _dsTipo = dsTipo,
        _dsDispensa = dsDispensa,
        _dsObservacao = dsObservacao,
        _cdLinkJuno = cdLinkJuno,
        _nrBoleto = nrBoleto,
        _nrTtlBoletoContrato = nrTtlBoletoContrato,
        _flPago = flPago,
        _vrBoleto = vrBoleto,
        _idCarne = idCarne,
        _vrPago = vrPago,
        _vrAgendado = vrAgendado,
        _idAcao = idAcao,
        _idOs = idOs,
        _idVenda = idVenda,
        _idBoleto = idBoleto,
        _carneQtParcelas = carneQtParcelas;

  // "cdBarras" field.
  String? _cdBarras;
  String get cdBarras => _cdBarras ?? '';
  set cdBarras(String? val) => _cdBarras = val;

  bool hasCdBarras() => _cdBarras != null;

  // "cdNossoNumero" field.
  String? _cdNossoNumero;
  String get cdNossoNumero => _cdNossoNumero ?? '';
  set cdNossoNumero(String? val) => _cdNossoNumero = val;

  bool hasCdNossoNumero() => _cdNossoNumero != null;

  // "cdLinhaDigitavel" field.
  String? _cdLinhaDigitavel;
  String get cdLinhaDigitavel => _cdLinhaDigitavel ?? '';
  set cdLinhaDigitavel(String? val) => _cdLinhaDigitavel = val;

  bool hasCdLinhaDigitavel() => _cdLinhaDigitavel != null;

  // "idContrato" field.
  int? _idContrato;
  int get idContrato => _idContrato ?? 0;
  set idContrato(int? val) => _idContrato = val;

  void incrementIdContrato(int amount) => idContrato = idContrato + amount;

  bool hasIdContrato() => _idContrato != null;

  // "idDocumento" field.
  int? _idDocumento;
  int get idDocumento => _idDocumento ?? 0;
  set idDocumento(int? val) => _idDocumento = val;

  void incrementIdDocumento(int amount) => idDocumento = idDocumento + amount;

  bool hasIdDocumento() => _idDocumento != null;

  // "cdTipoCobranca" field.
  String? _cdTipoCobranca;
  String get cdTipoCobranca => _cdTipoCobranca ?? '';
  set cdTipoCobranca(String? val) => _cdTipoCobranca = val;

  bool hasCdTipoCobranca() => _cdTipoCobranca != null;

  // "dtVencimento" field.
  String? _dtVencimento;
  String get dtVencimento => _dtVencimento ?? '';
  set dtVencimento(String? val) => _dtVencimento = val;

  bool hasDtVencimento() => _dtVencimento != null;

  // "dtVencimentoCodBarras" field.
  String? _dtVencimentoCodBarras;
  String get dtVencimentoCodBarras => _dtVencimentoCodBarras ?? '';
  set dtVencimentoCodBarras(String? val) => _dtVencimentoCodBarras = val;

  bool hasDtVencimentoCodBarras() => _dtVencimentoCodBarras != null;

  // "cdReferencia" field.
  String? _cdReferencia;
  String get cdReferencia => _cdReferencia ?? '';
  set cdReferencia(String? val) => _cdReferencia = val;

  bool hasCdReferencia() => _cdReferencia != null;

  // "idPessoa" field.
  int? _idPessoa;
  int get idPessoa => _idPessoa ?? 0;
  set idPessoa(int? val) => _idPessoa = val;

  void incrementIdPessoa(int amount) => idPessoa = idPessoa + amount;

  bool hasIdPessoa() => _idPessoa != null;

  // "idCliente" field.
  int? _idCliente;
  int get idCliente => _idCliente ?? 0;
  set idCliente(int? val) => _idCliente = val;

  void incrementIdCliente(int amount) => idCliente = idCliente + amount;

  bool hasIdCliente() => _idCliente != null;

  // "idDoc" field.
  int? _idDoc;
  int get idDoc => _idDoc ?? 0;
  set idDoc(int? val) => _idDoc = val;

  void incrementIdDoc(int amount) => idDoc = idDoc + amount;

  bool hasIdDoc() => _idDoc != null;

  // "idContaBoleto" field.
  int? _idContaBoleto;
  int get idContaBoleto => _idContaBoleto ?? 0;
  set idContaBoleto(int? val) => _idContaBoleto = val;

  void incrementIdContaBoleto(int amount) =>
      idContaBoleto = idContaBoleto + amount;

  bool hasIdContaBoleto() => _idContaBoleto != null;

  // "nmConta" field.
  String? _nmConta;
  String get nmConta => _nmConta ?? '';
  set nmConta(String? val) => _nmConta = val;

  bool hasNmConta() => _nmConta != null;

  // "nmBeneficiario" field.
  String? _nmBeneficiario;
  String get nmBeneficiario => _nmBeneficiario ?? '';
  set nmBeneficiario(String? val) => _nmBeneficiario = val;

  bool hasNmBeneficiario() => _nmBeneficiario != null;

  // "flContaBancaria" field.
  bool? _flContaBancaria;
  bool get flContaBancaria => _flContaBancaria ?? false;
  set flContaBancaria(bool? val) => _flContaBancaria = val;

  bool hasFlContaBancaria() => _flContaBancaria != null;

  // "tpBoleto" field.
  String? _tpBoleto;
  String get tpBoleto => _tpBoleto ?? '';
  set tpBoleto(String? val) => _tpBoleto = val;

  bool hasTpBoleto() => _tpBoleto != null;

  // "nmUsuarioBaixou" field.
  String? _nmUsuarioBaixou;
  String get nmUsuarioBaixou => _nmUsuarioBaixou ?? '';
  set nmUsuarioBaixou(String? val) => _nmUsuarioBaixou = val;

  bool hasNmUsuarioBaixou() => _nmUsuarioBaixou != null;

  // "nmUsuarioTratouRetorno" field.
  String? _nmUsuarioTratouRetorno;
  String get nmUsuarioTratouRetorno => _nmUsuarioTratouRetorno ?? '';
  set nmUsuarioTratouRetorno(String? val) => _nmUsuarioTratouRetorno = val;

  bool hasNmUsuarioTratouRetorno() => _nmUsuarioTratouRetorno != null;

  // "cdCentroCustoBaixou" field.
  String? _cdCentroCustoBaixou;
  String get cdCentroCustoBaixou => _cdCentroCustoBaixou ?? '';
  set cdCentroCustoBaixou(String? val) => _cdCentroCustoBaixou = val;

  bool hasCdCentroCustoBaixou() => _cdCentroCustoBaixou != null;

  // "nmCentroCustoBaixou" field.
  String? _nmCentroCustoBaixou;
  String get nmCentroCustoBaixou => _nmCentroCustoBaixou ?? '';
  set nmCentroCustoBaixou(String? val) => _nmCentroCustoBaixou = val;

  bool hasNmCentroCustoBaixou() => _nmCentroCustoBaixou != null;

  // "nmUnidadeColeta" field.
  String? _nmUnidadeColeta;
  String get nmUnidadeColeta => _nmUnidadeColeta ?? '';
  set nmUnidadeColeta(String? val) => _nmUnidadeColeta = val;

  bool hasNmUnidadeColeta() => _nmUnidadeColeta != null;

  // "dtPago" field.
  String? _dtPago;
  String get dtPago => _dtPago ?? '';
  set dtPago(String? val) => _dtPago = val;

  bool hasDtPago() => _dtPago != null;

  // "dtSistemaBaixa" field.
  String? _dtSistemaBaixa;
  String get dtSistemaBaixa => _dtSistemaBaixa ?? '';
  set dtSistemaBaixa(String? val) => _dtSistemaBaixa = val;

  bool hasDtSistemaBaixa() => _dtSistemaBaixa != null;

  // "dtCredito" field.
  String? _dtCredito;
  String get dtCredito => _dtCredito ?? '';
  set dtCredito(String? val) => _dtCredito = val;

  bool hasDtCredito() => _dtCredito != null;

  // "dtRetornoTratado" field.
  String? _dtRetornoTratado;
  String get dtRetornoTratado => _dtRetornoTratado ?? '';
  set dtRetornoTratado(String? val) => _dtRetornoTratado = val;

  bool hasDtRetornoTratado() => _dtRetornoTratado != null;

  // "vrAcrescimo" field.
  int? _vrAcrescimo;
  int get vrAcrescimo => _vrAcrescimo ?? 0;
  set vrAcrescimo(int? val) => _vrAcrescimo = val;

  void incrementVrAcrescimo(int amount) => vrAcrescimo = vrAcrescimo + amount;

  bool hasVrAcrescimo() => _vrAcrescimo != null;

  // "vrDesconto" field.
  int? _vrDesconto;
  int get vrDesconto => _vrDesconto ?? 0;
  set vrDesconto(int? val) => _vrDesconto = val;

  void incrementVrDesconto(int amount) => vrDesconto = vrDesconto + amount;

  bool hasVrDesconto() => _vrDesconto != null;

  // "vrMultaJustos" field.
  int? _vrMultaJustos;
  int get vrMultaJustos => _vrMultaJustos ?? 0;
  set vrMultaJustos(int? val) => _vrMultaJustos = val;

  void incrementVrMultaJustos(int amount) =>
      vrMultaJustos = vrMultaJustos + amount;

  bool hasVrMultaJustos() => _vrMultaJustos != null;

  // "vrTarifa" field.
  int? _vrTarifa;
  int get vrTarifa => _vrTarifa ?? 0;
  set vrTarifa(int? val) => _vrTarifa = val;

  void incrementVrTarifa(int amount) => vrTarifa = vrTarifa + amount;

  bool hasVrTarifa() => _vrTarifa != null;

  // "vrParcial" field.
  int? _vrParcial;
  int get vrParcial => _vrParcial ?? 0;
  set vrParcial(int? val) => _vrParcial = val;

  void incrementVrParcial(int amount) => vrParcial = vrParcial + amount;

  bool hasVrParcial() => _vrParcial != null;

  // "carneDtVencimentoInicio" field.
  String? _carneDtVencimentoInicio;
  String get carneDtVencimentoInicio => _carneDtVencimentoInicio ?? '';
  set carneDtVencimentoInicio(String? val) => _carneDtVencimentoInicio = val;

  bool hasCarneDtVencimentoInicio() => _carneDtVencimentoInicio != null;

  // "carneDtValidade" field.
  String? _carneDtValidade;
  String get carneDtValidade => _carneDtValidade ?? '';
  set carneDtValidade(String? val) => _carneDtValidade = val;

  bool hasCarneDtValidade() => _carneDtValidade != null;

  // "dtAgendado" field.
  String? _dtAgendado;
  String get dtAgendado => _dtAgendado ?? '';
  set dtAgendado(String? val) => _dtAgendado = val;

  bool hasDtAgendado() => _dtAgendado != null;

  // "nmUsuarioAgendou" field.
  String? _nmUsuarioAgendou;
  String get nmUsuarioAgendou => _nmUsuarioAgendou ?? '';
  set nmUsuarioAgendou(String? val) => _nmUsuarioAgendou = val;

  bool hasNmUsuarioAgendou() => _nmUsuarioAgendou != null;

  // "dtSistemaGerado" field.
  String? _dtSistemaGerado;
  String get dtSistemaGerado => _dtSistemaGerado ?? '';
  set dtSistemaGerado(String? val) => _dtSistemaGerado = val;

  bool hasDtSistemaGerado() => _dtSistemaGerado != null;

  // "nmUsuarioGerou" field.
  String? _nmUsuarioGerou;
  String get nmUsuarioGerou => _nmUsuarioGerou ?? '';
  set nmUsuarioGerou(String? val) => _nmUsuarioGerou = val;

  bool hasNmUsuarioGerou() => _nmUsuarioGerou != null;

  // "dtExcluiu" field.
  String? _dtExcluiu;
  String get dtExcluiu => _dtExcluiu ?? '';
  set dtExcluiu(String? val) => _dtExcluiu = val;

  bool hasDtExcluiu() => _dtExcluiu != null;

  // "nmUsuarioExcluiu" field.
  String? _nmUsuarioExcluiu;
  String get nmUsuarioExcluiu => _nmUsuarioExcluiu ?? '';
  set nmUsuarioExcluiu(String? val) => _nmUsuarioExcluiu = val;

  bool hasNmUsuarioExcluiu() => _nmUsuarioExcluiu != null;

  // "dtDispensa" field.
  String? _dtDispensa;
  String get dtDispensa => _dtDispensa ?? '';
  set dtDispensa(String? val) => _dtDispensa = val;

  bool hasDtDispensa() => _dtDispensa != null;

  // "nmUsuarioDispensou" field.
  String? _nmUsuarioDispensou;
  String get nmUsuarioDispensou => _nmUsuarioDispensou ?? '';
  set nmUsuarioDispensou(String? val) => _nmUsuarioDispensou = val;

  bool hasNmUsuarioDispensou() => _nmUsuarioDispensou != null;

  // "dsTipo" field.
  String? _dsTipo;
  String get dsTipo => _dsTipo ?? '';
  set dsTipo(String? val) => _dsTipo = val;

  bool hasDsTipo() => _dsTipo != null;

  // "dsDispensa" field.
  String? _dsDispensa;
  String get dsDispensa => _dsDispensa ?? '';
  set dsDispensa(String? val) => _dsDispensa = val;

  bool hasDsDispensa() => _dsDispensa != null;

  // "dsObservacao" field.
  String? _dsObservacao;
  String get dsObservacao => _dsObservacao ?? '';
  set dsObservacao(String? val) => _dsObservacao = val;

  bool hasDsObservacao() => _dsObservacao != null;

  // "cdLinkJuno" field.
  String? _cdLinkJuno;
  String get cdLinkJuno => _cdLinkJuno ?? '';
  set cdLinkJuno(String? val) => _cdLinkJuno = val;

  bool hasCdLinkJuno() => _cdLinkJuno != null;

  // "nrBoleto" field.
  int? _nrBoleto;
  int get nrBoleto => _nrBoleto ?? 0;
  set nrBoleto(int? val) => _nrBoleto = val;

  void incrementNrBoleto(int amount) => nrBoleto = nrBoleto + amount;

  bool hasNrBoleto() => _nrBoleto != null;

  // "nrTtlBoletoContrato" field.
  int? _nrTtlBoletoContrato;
  int get nrTtlBoletoContrato => _nrTtlBoletoContrato ?? 0;
  set nrTtlBoletoContrato(int? val) => _nrTtlBoletoContrato = val;

  void incrementNrTtlBoletoContrato(int amount) =>
      nrTtlBoletoContrato = nrTtlBoletoContrato + amount;

  bool hasNrTtlBoletoContrato() => _nrTtlBoletoContrato != null;

  // "flPago" field.
  bool? _flPago;
  bool get flPago => _flPago ?? false;
  set flPago(bool? val) => _flPago = val;

  bool hasFlPago() => _flPago != null;

  // "vrBoleto" field.
  double? _vrBoleto;
  double get vrBoleto => _vrBoleto ?? 0.0;
  set vrBoleto(double? val) => _vrBoleto = val;

  void incrementVrBoleto(double amount) => vrBoleto = vrBoleto + amount;

  bool hasVrBoleto() => _vrBoleto != null;

  // "idCarne" field.
  int? _idCarne;
  int get idCarne => _idCarne ?? 0;
  set idCarne(int? val) => _idCarne = val;

  void incrementIdCarne(int amount) => idCarne = idCarne + amount;

  bool hasIdCarne() => _idCarne != null;

  // "vrPago" field.
  int? _vrPago;
  int get vrPago => _vrPago ?? 0;
  set vrPago(int? val) => _vrPago = val;

  void incrementVrPago(int amount) => vrPago = vrPago + amount;

  bool hasVrPago() => _vrPago != null;

  // "vrAgendado" field.
  int? _vrAgendado;
  int get vrAgendado => _vrAgendado ?? 0;
  set vrAgendado(int? val) => _vrAgendado = val;

  void incrementVrAgendado(int amount) => vrAgendado = vrAgendado + amount;

  bool hasVrAgendado() => _vrAgendado != null;

  // "idAcao" field.
  int? _idAcao;
  int get idAcao => _idAcao ?? 0;
  set idAcao(int? val) => _idAcao = val;

  void incrementIdAcao(int amount) => idAcao = idAcao + amount;

  bool hasIdAcao() => _idAcao != null;

  // "idOs" field.
  int? _idOs;
  int get idOs => _idOs ?? 0;
  set idOs(int? val) => _idOs = val;

  void incrementIdOs(int amount) => idOs = idOs + amount;

  bool hasIdOs() => _idOs != null;

  // "idVenda" field.
  int? _idVenda;
  int get idVenda => _idVenda ?? 0;
  set idVenda(int? val) => _idVenda = val;

  void incrementIdVenda(int amount) => idVenda = idVenda + amount;

  bool hasIdVenda() => _idVenda != null;

  // "idBoleto" field.
  String? _idBoleto;
  String get idBoleto => _idBoleto ?? '';
  set idBoleto(String? val) => _idBoleto = val;

  bool hasIdBoleto() => _idBoleto != null;

  // "carneQtParcelas" field.
  int? _carneQtParcelas;
  int get carneQtParcelas => _carneQtParcelas ?? 0;
  set carneQtParcelas(int? val) => _carneQtParcelas = val;

  void incrementCarneQtParcelas(int amount) =>
      carneQtParcelas = carneQtParcelas + amount;

  bool hasCarneQtParcelas() => _carneQtParcelas != null;

  static FaturaStruct fromMap(Map<String, dynamic> data) => FaturaStruct(
        cdBarras: data['cdBarras'] as String?,
        cdNossoNumero: data['cdNossoNumero'] as String?,
        cdLinhaDigitavel: data['cdLinhaDigitavel'] as String?,
        idContrato: castToType<int>(data['idContrato']),
        idDocumento: castToType<int>(data['idDocumento']),
        cdTipoCobranca: data['cdTipoCobranca'] as String?,
        dtVencimento: data['dtVencimento'] as String?,
        dtVencimentoCodBarras: data['dtVencimentoCodBarras'] as String?,
        cdReferencia: data['cdReferencia'] as String?,
        idPessoa: castToType<int>(data['idPessoa']),
        idCliente: castToType<int>(data['idCliente']),
        idDoc: castToType<int>(data['idDoc']),
        idContaBoleto: castToType<int>(data['idContaBoleto']),
        nmConta: data['nmConta'] as String?,
        nmBeneficiario: data['nmBeneficiario'] as String?,
        flContaBancaria: data['flContaBancaria'] as bool?,
        tpBoleto: data['tpBoleto'] as String?,
        nmUsuarioBaixou: data['nmUsuarioBaixou'] as String?,
        nmUsuarioTratouRetorno: data['nmUsuarioTratouRetorno'] as String?,
        cdCentroCustoBaixou: data['cdCentroCustoBaixou'] as String?,
        nmCentroCustoBaixou: data['nmCentroCustoBaixou'] as String?,
        nmUnidadeColeta: data['nmUnidadeColeta'] as String?,
        dtPago: data['dtPago'] as String?,
        dtSistemaBaixa: data['dtSistemaBaixa'] as String?,
        dtCredito: data['dtCredito'] as String?,
        dtRetornoTratado: data['dtRetornoTratado'] as String?,
        vrAcrescimo: castToType<int>(data['vrAcrescimo']),
        vrDesconto: castToType<int>(data['vrDesconto']),
        vrMultaJustos: castToType<int>(data['vrMultaJustos']),
        vrTarifa: castToType<int>(data['vrTarifa']),
        vrParcial: castToType<int>(data['vrParcial']),
        carneDtVencimentoInicio: data['carneDtVencimentoInicio'] as String?,
        carneDtValidade: data['carneDtValidade'] as String?,
        dtAgendado: data['dtAgendado'] as String?,
        nmUsuarioAgendou: data['nmUsuarioAgendou'] as String?,
        dtSistemaGerado: data['dtSistemaGerado'] as String?,
        nmUsuarioGerou: data['nmUsuarioGerou'] as String?,
        dtExcluiu: data['dtExcluiu'] as String?,
        nmUsuarioExcluiu: data['nmUsuarioExcluiu'] as String?,
        dtDispensa: data['dtDispensa'] as String?,
        nmUsuarioDispensou: data['nmUsuarioDispensou'] as String?,
        dsTipo: data['dsTipo'] as String?,
        dsDispensa: data['dsDispensa'] as String?,
        dsObservacao: data['dsObservacao'] as String?,
        cdLinkJuno: data['cdLinkJuno'] as String?,
        nrBoleto: castToType<int>(data['nrBoleto']),
        nrTtlBoletoContrato: castToType<int>(data['nrTtlBoletoContrato']),
        flPago: data['flPago'] as bool?,
        vrBoleto: castToType<double>(data['vrBoleto']),
        idCarne: castToType<int>(data['idCarne']),
        vrPago: castToType<int>(data['vrPago']),
        vrAgendado: castToType<int>(data['vrAgendado']),
        idAcao: castToType<int>(data['idAcao']),
        idOs: castToType<int>(data['idOs']),
        idVenda: castToType<int>(data['idVenda']),
        idBoleto: data['idBoleto'] as String?,
        carneQtParcelas: castToType<int>(data['carneQtParcelas']),
      );

  static FaturaStruct? maybeFromMap(dynamic data) =>
      data is Map ? FaturaStruct.fromMap(data.cast<String, dynamic>()) : null;

  Map<String, dynamic> toMap() => {
        'cdBarras': _cdBarras,
        'cdNossoNumero': _cdNossoNumero,
        'cdLinhaDigitavel': _cdLinhaDigitavel,
        'idContrato': _idContrato,
        'idDocumento': _idDocumento,
        'cdTipoCobranca': _cdTipoCobranca,
        'dtVencimento': _dtVencimento,
        'dtVencimentoCodBarras': _dtVencimentoCodBarras,
        'cdReferencia': _cdReferencia,
        'idPessoa': _idPessoa,
        'idCliente': _idCliente,
        'idDoc': _idDoc,
        'idContaBoleto': _idContaBoleto,
        'nmConta': _nmConta,
        'nmBeneficiario': _nmBeneficiario,
        'flContaBancaria': _flContaBancaria,
        'tpBoleto': _tpBoleto,
        'nmUsuarioBaixou': _nmUsuarioBaixou,
        'nmUsuarioTratouRetorno': _nmUsuarioTratouRetorno,
        'cdCentroCustoBaixou': _cdCentroCustoBaixou,
        'nmCentroCustoBaixou': _nmCentroCustoBaixou,
        'nmUnidadeColeta': _nmUnidadeColeta,
        'dtPago': _dtPago,
        'dtSistemaBaixa': _dtSistemaBaixa,
        'dtCredito': _dtCredito,
        'dtRetornoTratado': _dtRetornoTratado,
        'vrAcrescimo': _vrAcrescimo,
        'vrDesconto': _vrDesconto,
        'vrMultaJustos': _vrMultaJustos,
        'vrTarifa': _vrTarifa,
        'vrParcial': _vrParcial,
        'carneDtVencimentoInicio': _carneDtVencimentoInicio,
        'carneDtValidade': _carneDtValidade,
        'dtAgendado': _dtAgendado,
        'nmUsuarioAgendou': _nmUsuarioAgendou,
        'dtSistemaGerado': _dtSistemaGerado,
        'nmUsuarioGerou': _nmUsuarioGerou,
        'dtExcluiu': _dtExcluiu,
        'nmUsuarioExcluiu': _nmUsuarioExcluiu,
        'dtDispensa': _dtDispensa,
        'nmUsuarioDispensou': _nmUsuarioDispensou,
        'dsTipo': _dsTipo,
        'dsDispensa': _dsDispensa,
        'dsObservacao': _dsObservacao,
        'cdLinkJuno': _cdLinkJuno,
        'nrBoleto': _nrBoleto,
        'nrTtlBoletoContrato': _nrTtlBoletoContrato,
        'flPago': _flPago,
        'vrBoleto': _vrBoleto,
        'idCarne': _idCarne,
        'vrPago': _vrPago,
        'vrAgendado': _vrAgendado,
        'idAcao': _idAcao,
        'idOs': _idOs,
        'idVenda': _idVenda,
        'idBoleto': _idBoleto,
        'carneQtParcelas': _carneQtParcelas,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'cdBarras': serializeParam(
          _cdBarras,
          ParamType.String,
        ),
        'cdNossoNumero': serializeParam(
          _cdNossoNumero,
          ParamType.String,
        ),
        'cdLinhaDigitavel': serializeParam(
          _cdLinhaDigitavel,
          ParamType.String,
        ),
        'idContrato': serializeParam(
          _idContrato,
          ParamType.int,
        ),
        'idDocumento': serializeParam(
          _idDocumento,
          ParamType.int,
        ),
        'cdTipoCobranca': serializeParam(
          _cdTipoCobranca,
          ParamType.String,
        ),
        'dtVencimento': serializeParam(
          _dtVencimento,
          ParamType.String,
        ),
        'dtVencimentoCodBarras': serializeParam(
          _dtVencimentoCodBarras,
          ParamType.String,
        ),
        'cdReferencia': serializeParam(
          _cdReferencia,
          ParamType.String,
        ),
        'idPessoa': serializeParam(
          _idPessoa,
          ParamType.int,
        ),
        'idCliente': serializeParam(
          _idCliente,
          ParamType.int,
        ),
        'idDoc': serializeParam(
          _idDoc,
          ParamType.int,
        ),
        'idContaBoleto': serializeParam(
          _idContaBoleto,
          ParamType.int,
        ),
        'nmConta': serializeParam(
          _nmConta,
          ParamType.String,
        ),
        'nmBeneficiario': serializeParam(
          _nmBeneficiario,
          ParamType.String,
        ),
        'flContaBancaria': serializeParam(
          _flContaBancaria,
          ParamType.bool,
        ),
        'tpBoleto': serializeParam(
          _tpBoleto,
          ParamType.String,
        ),
        'nmUsuarioBaixou': serializeParam(
          _nmUsuarioBaixou,
          ParamType.String,
        ),
        'nmUsuarioTratouRetorno': serializeParam(
          _nmUsuarioTratouRetorno,
          ParamType.String,
        ),
        'cdCentroCustoBaixou': serializeParam(
          _cdCentroCustoBaixou,
          ParamType.String,
        ),
        'nmCentroCustoBaixou': serializeParam(
          _nmCentroCustoBaixou,
          ParamType.String,
        ),
        'nmUnidadeColeta': serializeParam(
          _nmUnidadeColeta,
          ParamType.String,
        ),
        'dtPago': serializeParam(
          _dtPago,
          ParamType.String,
        ),
        'dtSistemaBaixa': serializeParam(
          _dtSistemaBaixa,
          ParamType.String,
        ),
        'dtCredito': serializeParam(
          _dtCredito,
          ParamType.String,
        ),
        'dtRetornoTratado': serializeParam(
          _dtRetornoTratado,
          ParamType.String,
        ),
        'vrAcrescimo': serializeParam(
          _vrAcrescimo,
          ParamType.int,
        ),
        'vrDesconto': serializeParam(
          _vrDesconto,
          ParamType.int,
        ),
        'vrMultaJustos': serializeParam(
          _vrMultaJustos,
          ParamType.int,
        ),
        'vrTarifa': serializeParam(
          _vrTarifa,
          ParamType.int,
        ),
        'vrParcial': serializeParam(
          _vrParcial,
          ParamType.int,
        ),
        'carneDtVencimentoInicio': serializeParam(
          _carneDtVencimentoInicio,
          ParamType.String,
        ),
        'carneDtValidade': serializeParam(
          _carneDtValidade,
          ParamType.String,
        ),
        'dtAgendado': serializeParam(
          _dtAgendado,
          ParamType.String,
        ),
        'nmUsuarioAgendou': serializeParam(
          _nmUsuarioAgendou,
          ParamType.String,
        ),
        'dtSistemaGerado': serializeParam(
          _dtSistemaGerado,
          ParamType.String,
        ),
        'nmUsuarioGerou': serializeParam(
          _nmUsuarioGerou,
          ParamType.String,
        ),
        'dtExcluiu': serializeParam(
          _dtExcluiu,
          ParamType.String,
        ),
        'nmUsuarioExcluiu': serializeParam(
          _nmUsuarioExcluiu,
          ParamType.String,
        ),
        'dtDispensa': serializeParam(
          _dtDispensa,
          ParamType.String,
        ),
        'nmUsuarioDispensou': serializeParam(
          _nmUsuarioDispensou,
          ParamType.String,
        ),
        'dsTipo': serializeParam(
          _dsTipo,
          ParamType.String,
        ),
        'dsDispensa': serializeParam(
          _dsDispensa,
          ParamType.String,
        ),
        'dsObservacao': serializeParam(
          _dsObservacao,
          ParamType.String,
        ),
        'cdLinkJuno': serializeParam(
          _cdLinkJuno,
          ParamType.String,
        ),
        'nrBoleto': serializeParam(
          _nrBoleto,
          ParamType.int,
        ),
        'nrTtlBoletoContrato': serializeParam(
          _nrTtlBoletoContrato,
          ParamType.int,
        ),
        'flPago': serializeParam(
          _flPago,
          ParamType.bool,
        ),
        'vrBoleto': serializeParam(
          _vrBoleto,
          ParamType.double,
        ),
        'idCarne': serializeParam(
          _idCarne,
          ParamType.int,
        ),
        'vrPago': serializeParam(
          _vrPago,
          ParamType.int,
        ),
        'vrAgendado': serializeParam(
          _vrAgendado,
          ParamType.int,
        ),
        'idAcao': serializeParam(
          _idAcao,
          ParamType.int,
        ),
        'idOs': serializeParam(
          _idOs,
          ParamType.int,
        ),
        'idVenda': serializeParam(
          _idVenda,
          ParamType.int,
        ),
        'idBoleto': serializeParam(
          _idBoleto,
          ParamType.String,
        ),
        'carneQtParcelas': serializeParam(
          _carneQtParcelas,
          ParamType.int,
        ),
      }.withoutNulls;

  static FaturaStruct fromSerializableMap(Map<String, dynamic> data) =>
      FaturaStruct(
        cdBarras: deserializeParam(
          data['cdBarras'],
          ParamType.String,
          false,
        ),
        cdNossoNumero: deserializeParam(
          data['cdNossoNumero'],
          ParamType.String,
          false,
        ),
        cdLinhaDigitavel: deserializeParam(
          data['cdLinhaDigitavel'],
          ParamType.String,
          false,
        ),
        idContrato: deserializeParam(
          data['idContrato'],
          ParamType.int,
          false,
        ),
        idDocumento: deserializeParam(
          data['idDocumento'],
          ParamType.int,
          false,
        ),
        cdTipoCobranca: deserializeParam(
          data['cdTipoCobranca'],
          ParamType.String,
          false,
        ),
        dtVencimento: deserializeParam(
          data['dtVencimento'],
          ParamType.String,
          false,
        ),
        dtVencimentoCodBarras: deserializeParam(
          data['dtVencimentoCodBarras'],
          ParamType.String,
          false,
        ),
        cdReferencia: deserializeParam(
          data['cdReferencia'],
          ParamType.String,
          false,
        ),
        idPessoa: deserializeParam(
          data['idPessoa'],
          ParamType.int,
          false,
        ),
        idCliente: deserializeParam(
          data['idCliente'],
          ParamType.int,
          false,
        ),
        idDoc: deserializeParam(
          data['idDoc'],
          ParamType.int,
          false,
        ),
        idContaBoleto: deserializeParam(
          data['idContaBoleto'],
          ParamType.int,
          false,
        ),
        nmConta: deserializeParam(
          data['nmConta'],
          ParamType.String,
          false,
        ),
        nmBeneficiario: deserializeParam(
          data['nmBeneficiario'],
          ParamType.String,
          false,
        ),
        flContaBancaria: deserializeParam(
          data['flContaBancaria'],
          ParamType.bool,
          false,
        ),
        tpBoleto: deserializeParam(
          data['tpBoleto'],
          ParamType.String,
          false,
        ),
        nmUsuarioBaixou: deserializeParam(
          data['nmUsuarioBaixou'],
          ParamType.String,
          false,
        ),
        nmUsuarioTratouRetorno: deserializeParam(
          data['nmUsuarioTratouRetorno'],
          ParamType.String,
          false,
        ),
        cdCentroCustoBaixou: deserializeParam(
          data['cdCentroCustoBaixou'],
          ParamType.String,
          false,
        ),
        nmCentroCustoBaixou: deserializeParam(
          data['nmCentroCustoBaixou'],
          ParamType.String,
          false,
        ),
        nmUnidadeColeta: deserializeParam(
          data['nmUnidadeColeta'],
          ParamType.String,
          false,
        ),
        dtPago: deserializeParam(
          data['dtPago'],
          ParamType.String,
          false,
        ),
        dtSistemaBaixa: deserializeParam(
          data['dtSistemaBaixa'],
          ParamType.String,
          false,
        ),
        dtCredito: deserializeParam(
          data['dtCredito'],
          ParamType.String,
          false,
        ),
        dtRetornoTratado: deserializeParam(
          data['dtRetornoTratado'],
          ParamType.String,
          false,
        ),
        vrAcrescimo: deserializeParam(
          data['vrAcrescimo'],
          ParamType.int,
          false,
        ),
        vrDesconto: deserializeParam(
          data['vrDesconto'],
          ParamType.int,
          false,
        ),
        vrMultaJustos: deserializeParam(
          data['vrMultaJustos'],
          ParamType.int,
          false,
        ),
        vrTarifa: deserializeParam(
          data['vrTarifa'],
          ParamType.int,
          false,
        ),
        vrParcial: deserializeParam(
          data['vrParcial'],
          ParamType.int,
          false,
        ),
        carneDtVencimentoInicio: deserializeParam(
          data['carneDtVencimentoInicio'],
          ParamType.String,
          false,
        ),
        carneDtValidade: deserializeParam(
          data['carneDtValidade'],
          ParamType.String,
          false,
        ),
        dtAgendado: deserializeParam(
          data['dtAgendado'],
          ParamType.String,
          false,
        ),
        nmUsuarioAgendou: deserializeParam(
          data['nmUsuarioAgendou'],
          ParamType.String,
          false,
        ),
        dtSistemaGerado: deserializeParam(
          data['dtSistemaGerado'],
          ParamType.String,
          false,
        ),
        nmUsuarioGerou: deserializeParam(
          data['nmUsuarioGerou'],
          ParamType.String,
          false,
        ),
        dtExcluiu: deserializeParam(
          data['dtExcluiu'],
          ParamType.String,
          false,
        ),
        nmUsuarioExcluiu: deserializeParam(
          data['nmUsuarioExcluiu'],
          ParamType.String,
          false,
        ),
        dtDispensa: deserializeParam(
          data['dtDispensa'],
          ParamType.String,
          false,
        ),
        nmUsuarioDispensou: deserializeParam(
          data['nmUsuarioDispensou'],
          ParamType.String,
          false,
        ),
        dsTipo: deserializeParam(
          data['dsTipo'],
          ParamType.String,
          false,
        ),
        dsDispensa: deserializeParam(
          data['dsDispensa'],
          ParamType.String,
          false,
        ),
        dsObservacao: deserializeParam(
          data['dsObservacao'],
          ParamType.String,
          false,
        ),
        cdLinkJuno: deserializeParam(
          data['cdLinkJuno'],
          ParamType.String,
          false,
        ),
        nrBoleto: deserializeParam(
          data['nrBoleto'],
          ParamType.int,
          false,
        ),
        nrTtlBoletoContrato: deserializeParam(
          data['nrTtlBoletoContrato'],
          ParamType.int,
          false,
        ),
        flPago: deserializeParam(
          data['flPago'],
          ParamType.bool,
          false,
        ),
        vrBoleto: deserializeParam(
          data['vrBoleto'],
          ParamType.double,
          false,
        ),
        idCarne: deserializeParam(
          data['idCarne'],
          ParamType.int,
          false,
        ),
        vrPago: deserializeParam(
          data['vrPago'],
          ParamType.int,
          false,
        ),
        vrAgendado: deserializeParam(
          data['vrAgendado'],
          ParamType.int,
          false,
        ),
        idAcao: deserializeParam(
          data['idAcao'],
          ParamType.int,
          false,
        ),
        idOs: deserializeParam(
          data['idOs'],
          ParamType.int,
          false,
        ),
        idVenda: deserializeParam(
          data['idVenda'],
          ParamType.int,
          false,
        ),
        idBoleto: deserializeParam(
          data['idBoleto'],
          ParamType.String,
          false,
        ),
        carneQtParcelas: deserializeParam(
          data['carneQtParcelas'],
          ParamType.int,
          false,
        ),
      );

  @override
  String toString() => 'FaturaStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is FaturaStruct &&
        cdBarras == other.cdBarras &&
        cdNossoNumero == other.cdNossoNumero &&
        cdLinhaDigitavel == other.cdLinhaDigitavel &&
        idContrato == other.idContrato &&
        idDocumento == other.idDocumento &&
        cdTipoCobranca == other.cdTipoCobranca &&
        dtVencimento == other.dtVencimento &&
        dtVencimentoCodBarras == other.dtVencimentoCodBarras &&
        cdReferencia == other.cdReferencia &&
        idPessoa == other.idPessoa &&
        idCliente == other.idCliente &&
        idDoc == other.idDoc &&
        idContaBoleto == other.idContaBoleto &&
        nmConta == other.nmConta &&
        nmBeneficiario == other.nmBeneficiario &&
        flContaBancaria == other.flContaBancaria &&
        tpBoleto == other.tpBoleto &&
        nmUsuarioBaixou == other.nmUsuarioBaixou &&
        nmUsuarioTratouRetorno == other.nmUsuarioTratouRetorno &&
        cdCentroCustoBaixou == other.cdCentroCustoBaixou &&
        nmCentroCustoBaixou == other.nmCentroCustoBaixou &&
        nmUnidadeColeta == other.nmUnidadeColeta &&
        dtPago == other.dtPago &&
        dtSistemaBaixa == other.dtSistemaBaixa &&
        dtCredito == other.dtCredito &&
        dtRetornoTratado == other.dtRetornoTratado &&
        vrAcrescimo == other.vrAcrescimo &&
        vrDesconto == other.vrDesconto &&
        vrMultaJustos == other.vrMultaJustos &&
        vrTarifa == other.vrTarifa &&
        vrParcial == other.vrParcial &&
        carneDtVencimentoInicio == other.carneDtVencimentoInicio &&
        carneDtValidade == other.carneDtValidade &&
        dtAgendado == other.dtAgendado &&
        nmUsuarioAgendou == other.nmUsuarioAgendou &&
        dtSistemaGerado == other.dtSistemaGerado &&
        nmUsuarioGerou == other.nmUsuarioGerou &&
        dtExcluiu == other.dtExcluiu &&
        nmUsuarioExcluiu == other.nmUsuarioExcluiu &&
        dtDispensa == other.dtDispensa &&
        nmUsuarioDispensou == other.nmUsuarioDispensou &&
        dsTipo == other.dsTipo &&
        dsDispensa == other.dsDispensa &&
        dsObservacao == other.dsObservacao &&
        cdLinkJuno == other.cdLinkJuno &&
        nrBoleto == other.nrBoleto &&
        nrTtlBoletoContrato == other.nrTtlBoletoContrato &&
        flPago == other.flPago &&
        vrBoleto == other.vrBoleto &&
        idCarne == other.idCarne &&
        vrPago == other.vrPago &&
        vrAgendado == other.vrAgendado &&
        idAcao == other.idAcao &&
        idOs == other.idOs &&
        idVenda == other.idVenda &&
        idBoleto == other.idBoleto &&
        carneQtParcelas == other.carneQtParcelas;
  }

  @override
  int get hashCode => const ListEquality().hash([
        cdBarras,
        cdNossoNumero,
        cdLinhaDigitavel,
        idContrato,
        idDocumento,
        cdTipoCobranca,
        dtVencimento,
        dtVencimentoCodBarras,
        cdReferencia,
        idPessoa,
        idCliente,
        idDoc,
        idContaBoleto,
        nmConta,
        nmBeneficiario,
        flContaBancaria,
        tpBoleto,
        nmUsuarioBaixou,
        nmUsuarioTratouRetorno,
        cdCentroCustoBaixou,
        nmCentroCustoBaixou,
        nmUnidadeColeta,
        dtPago,
        dtSistemaBaixa,
        dtCredito,
        dtRetornoTratado,
        vrAcrescimo,
        vrDesconto,
        vrMultaJustos,
        vrTarifa,
        vrParcial,
        carneDtVencimentoInicio,
        carneDtValidade,
        dtAgendado,
        nmUsuarioAgendou,
        dtSistemaGerado,
        nmUsuarioGerou,
        dtExcluiu,
        nmUsuarioExcluiu,
        dtDispensa,
        nmUsuarioDispensou,
        dsTipo,
        dsDispensa,
        dsObservacao,
        cdLinkJuno,
        nrBoleto,
        nrTtlBoletoContrato,
        flPago,
        vrBoleto,
        idCarne,
        vrPago,
        vrAgendado,
        idAcao,
        idOs,
        idVenda,
        idBoleto,
        carneQtParcelas
      ]);
}

FaturaStruct createFaturaStruct({
  String? cdBarras,
  String? cdNossoNumero,
  String? cdLinhaDigitavel,
  int? idContrato,
  int? idDocumento,
  String? cdTipoCobranca,
  String? dtVencimento,
  String? dtVencimentoCodBarras,
  String? cdReferencia,
  int? idPessoa,
  int? idCliente,
  int? idDoc,
  int? idContaBoleto,
  String? nmConta,
  String? nmBeneficiario,
  bool? flContaBancaria,
  String? tpBoleto,
  String? nmUsuarioBaixou,
  String? nmUsuarioTratouRetorno,
  String? cdCentroCustoBaixou,
  String? nmCentroCustoBaixou,
  String? nmUnidadeColeta,
  String? dtPago,
  String? dtSistemaBaixa,
  String? dtCredito,
  String? dtRetornoTratado,
  int? vrAcrescimo,
  int? vrDesconto,
  int? vrMultaJustos,
  int? vrTarifa,
  int? vrParcial,
  String? carneDtVencimentoInicio,
  String? carneDtValidade,
  String? dtAgendado,
  String? nmUsuarioAgendou,
  String? dtSistemaGerado,
  String? nmUsuarioGerou,
  String? dtExcluiu,
  String? nmUsuarioExcluiu,
  String? dtDispensa,
  String? nmUsuarioDispensou,
  String? dsTipo,
  String? dsDispensa,
  String? dsObservacao,
  String? cdLinkJuno,
  int? nrBoleto,
  int? nrTtlBoletoContrato,
  bool? flPago,
  double? vrBoleto,
  int? idCarne,
  int? vrPago,
  int? vrAgendado,
  int? idAcao,
  int? idOs,
  int? idVenda,
  String? idBoleto,
  int? carneQtParcelas,
}) =>
    FaturaStruct(
      cdBarras: cdBarras,
      cdNossoNumero: cdNossoNumero,
      cdLinhaDigitavel: cdLinhaDigitavel,
      idContrato: idContrato,
      idDocumento: idDocumento,
      cdTipoCobranca: cdTipoCobranca,
      dtVencimento: dtVencimento,
      dtVencimentoCodBarras: dtVencimentoCodBarras,
      cdReferencia: cdReferencia,
      idPessoa: idPessoa,
      idCliente: idCliente,
      idDoc: idDoc,
      idContaBoleto: idContaBoleto,
      nmConta: nmConta,
      nmBeneficiario: nmBeneficiario,
      flContaBancaria: flContaBancaria,
      tpBoleto: tpBoleto,
      nmUsuarioBaixou: nmUsuarioBaixou,
      nmUsuarioTratouRetorno: nmUsuarioTratouRetorno,
      cdCentroCustoBaixou: cdCentroCustoBaixou,
      nmCentroCustoBaixou: nmCentroCustoBaixou,
      nmUnidadeColeta: nmUnidadeColeta,
      dtPago: dtPago,
      dtSistemaBaixa: dtSistemaBaixa,
      dtCredito: dtCredito,
      dtRetornoTratado: dtRetornoTratado,
      vrAcrescimo: vrAcrescimo,
      vrDesconto: vrDesconto,
      vrMultaJustos: vrMultaJustos,
      vrTarifa: vrTarifa,
      vrParcial: vrParcial,
      carneDtVencimentoInicio: carneDtVencimentoInicio,
      carneDtValidade: carneDtValidade,
      dtAgendado: dtAgendado,
      nmUsuarioAgendou: nmUsuarioAgendou,
      dtSistemaGerado: dtSistemaGerado,
      nmUsuarioGerou: nmUsuarioGerou,
      dtExcluiu: dtExcluiu,
      nmUsuarioExcluiu: nmUsuarioExcluiu,
      dtDispensa: dtDispensa,
      nmUsuarioDispensou: nmUsuarioDispensou,
      dsTipo: dsTipo,
      dsDispensa: dsDispensa,
      dsObservacao: dsObservacao,
      cdLinkJuno: cdLinkJuno,
      nrBoleto: nrBoleto,
      nrTtlBoletoContrato: nrTtlBoletoContrato,
      flPago: flPago,
      vrBoleto: vrBoleto,
      idCarne: idCarne,
      vrPago: vrPago,
      vrAgendado: vrAgendado,
      idAcao: idAcao,
      idOs: idOs,
      idVenda: idVenda,
      idBoleto: idBoleto,
      carneQtParcelas: carneQtParcelas,
    );
