// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class RepresentanteDataTypeStruct extends BaseStruct {
  RepresentanteDataTypeStruct({
    String? cdCep,
    String? dsLote,
    String? nmBairro,
    String? nrLogradouro,
    String? dsQuadra,
    String? nmLogradouroCompleto,
    String? nmCidade,
    String? sgEstado,
    String? cdTelMovel,
    String? cdTelResidencial,
    String? dsComplemento,
  })  : _cdCep = cdCep,
        _dsLote = dsLote,
        _nmBairro = nmBairro,
        _nrLogradouro = nrLogradouro,
        _dsQuadra = dsQuadra,
        _nmLogradouroCompleto = nmLogradouroCompleto,
        _nmCidade = nmCidade,
        _sgEstado = sgEstado,
        _cdTelMovel = cdTelMovel,
        _cdTelResidencial = cdTelResidencial,
        _dsComplemento = dsComplemento;

  // "cdCep" field.
  String? _cdCep;
  String get cdCep => _cdCep ?? '';
  set cdCep(String? val) => _cdCep = val;

  bool hasCdCep() => _cdCep != null;

  // "dsLote" field.
  String? _dsLote;
  String get dsLote => _dsLote ?? '';
  set dsLote(String? val) => _dsLote = val;

  bool hasDsLote() => _dsLote != null;

  // "nmBairro" field.
  String? _nmBairro;
  String get nmBairro => _nmBairro ?? '';
  set nmBairro(String? val) => _nmBairro = val;

  bool hasNmBairro() => _nmBairro != null;

  // "nrLogradouro" field.
  String? _nrLogradouro;
  String get nrLogradouro => _nrLogradouro ?? '';
  set nrLogradouro(String? val) => _nrLogradouro = val;

  bool hasNrLogradouro() => _nrLogradouro != null;

  // "dsQuadra" field.
  String? _dsQuadra;
  String get dsQuadra => _dsQuadra ?? '';
  set dsQuadra(String? val) => _dsQuadra = val;

  bool hasDsQuadra() => _dsQuadra != null;

  // "nmLogradouroCompleto" field.
  String? _nmLogradouroCompleto;
  String get nmLogradouroCompleto => _nmLogradouroCompleto ?? '';
  set nmLogradouroCompleto(String? val) => _nmLogradouroCompleto = val;

  bool hasNmLogradouroCompleto() => _nmLogradouroCompleto != null;

  // "nmCidade" field.
  String? _nmCidade;
  String get nmCidade => _nmCidade ?? '';
  set nmCidade(String? val) => _nmCidade = val;

  bool hasNmCidade() => _nmCidade != null;

  // "sgEstado" field.
  String? _sgEstado;
  String get sgEstado => _sgEstado ?? '';
  set sgEstado(String? val) => _sgEstado = val;

  bool hasSgEstado() => _sgEstado != null;

  // "cdTelMovel" field.
  String? _cdTelMovel;
  String get cdTelMovel => _cdTelMovel ?? '';
  set cdTelMovel(String? val) => _cdTelMovel = val;

  bool hasCdTelMovel() => _cdTelMovel != null;

  // "cdTelResidencial" field.
  String? _cdTelResidencial;
  String get cdTelResidencial => _cdTelResidencial ?? '';
  set cdTelResidencial(String? val) => _cdTelResidencial = val;

  bool hasCdTelResidencial() => _cdTelResidencial != null;

  // "dsComplemento" field.
  String? _dsComplemento;
  String get dsComplemento => _dsComplemento ?? '';
  set dsComplemento(String? val) => _dsComplemento = val;

  bool hasDsComplemento() => _dsComplemento != null;

  static RepresentanteDataTypeStruct fromMap(Map<String, dynamic> data) =>
      RepresentanteDataTypeStruct(
        cdCep: data['cdCep'] as String?,
        dsLote: data['dsLote'] as String?,
        nmBairro: data['nmBairro'] as String?,
        nrLogradouro: data['nrLogradouro'] as String?,
        dsQuadra: data['dsQuadra'] as String?,
        nmLogradouroCompleto: data['nmLogradouroCompleto'] as String?,
        nmCidade: data['nmCidade'] as String?,
        sgEstado: data['sgEstado'] as String?,
        cdTelMovel: data['cdTelMovel'] as String?,
        cdTelResidencial: data['cdTelResidencial'] as String?,
        dsComplemento: data['dsComplemento'] as String?,
      );

  static RepresentanteDataTypeStruct? maybeFromMap(dynamic data) => data is Map
      ? RepresentanteDataTypeStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'cdCep': _cdCep,
        'dsLote': _dsLote,
        'nmBairro': _nmBairro,
        'nrLogradouro': _nrLogradouro,
        'dsQuadra': _dsQuadra,
        'nmLogradouroCompleto': _nmLogradouroCompleto,
        'nmCidade': _nmCidade,
        'sgEstado': _sgEstado,
        'cdTelMovel': _cdTelMovel,
        'cdTelResidencial': _cdTelResidencial,
        'dsComplemento': _dsComplemento,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'cdCep': serializeParam(
          _cdCep,
          ParamType.String,
        ),
        'dsLote': serializeParam(
          _dsLote,
          ParamType.String,
        ),
        'nmBairro': serializeParam(
          _nmBairro,
          ParamType.String,
        ),
        'nrLogradouro': serializeParam(
          _nrLogradouro,
          ParamType.String,
        ),
        'dsQuadra': serializeParam(
          _dsQuadra,
          ParamType.String,
        ),
        'nmLogradouroCompleto': serializeParam(
          _nmLogradouroCompleto,
          ParamType.String,
        ),
        'nmCidade': serializeParam(
          _nmCidade,
          ParamType.String,
        ),
        'sgEstado': serializeParam(
          _sgEstado,
          ParamType.String,
        ),
        'cdTelMovel': serializeParam(
          _cdTelMovel,
          ParamType.String,
        ),
        'cdTelResidencial': serializeParam(
          _cdTelResidencial,
          ParamType.String,
        ),
        'dsComplemento': serializeParam(
          _dsComplemento,
          ParamType.String,
        ),
      }.withoutNulls;

  static RepresentanteDataTypeStruct fromSerializableMap(
          Map<String, dynamic> data) =>
      RepresentanteDataTypeStruct(
        cdCep: deserializeParam(
          data['cdCep'],
          ParamType.String,
          false,
        ),
        dsLote: deserializeParam(
          data['dsLote'],
          ParamType.String,
          false,
        ),
        nmBairro: deserializeParam(
          data['nmBairro'],
          ParamType.String,
          false,
        ),
        nrLogradouro: deserializeParam(
          data['nrLogradouro'],
          ParamType.String,
          false,
        ),
        dsQuadra: deserializeParam(
          data['dsQuadra'],
          ParamType.String,
          false,
        ),
        nmLogradouroCompleto: deserializeParam(
          data['nmLogradouroCompleto'],
          ParamType.String,
          false,
        ),
        nmCidade: deserializeParam(
          data['nmCidade'],
          ParamType.String,
          false,
        ),
        sgEstado: deserializeParam(
          data['sgEstado'],
          ParamType.String,
          false,
        ),
        cdTelMovel: deserializeParam(
          data['cdTelMovel'],
          ParamType.String,
          false,
        ),
        cdTelResidencial: deserializeParam(
          data['cdTelResidencial'],
          ParamType.String,
          false,
        ),
        dsComplemento: deserializeParam(
          data['dsComplemento'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'RepresentanteDataTypeStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is RepresentanteDataTypeStruct &&
        cdCep == other.cdCep &&
        dsLote == other.dsLote &&
        nmBairro == other.nmBairro &&
        nrLogradouro == other.nrLogradouro &&
        dsQuadra == other.dsQuadra &&
        nmLogradouroCompleto == other.nmLogradouroCompleto &&
        nmCidade == other.nmCidade &&
        sgEstado == other.sgEstado &&
        cdTelMovel == other.cdTelMovel &&
        cdTelResidencial == other.cdTelResidencial &&
        dsComplemento == other.dsComplemento;
  }

  @override
  int get hashCode => const ListEquality().hash([
        cdCep,
        dsLote,
        nmBairro,
        nrLogradouro,
        dsQuadra,
        nmLogradouroCompleto,
        nmCidade,
        sgEstado,
        cdTelMovel,
        cdTelResidencial,
        dsComplemento
      ]);
}

RepresentanteDataTypeStruct createRepresentanteDataTypeStruct({
  String? cdCep,
  String? dsLote,
  String? nmBairro,
  String? nrLogradouro,
  String? dsQuadra,
  String? nmLogradouroCompleto,
  String? nmCidade,
  String? sgEstado,
  String? cdTelMovel,
  String? cdTelResidencial,
  String? dsComplemento,
}) =>
    RepresentanteDataTypeStruct(
      cdCep: cdCep,
      dsLote: dsLote,
      nmBairro: nmBairro,
      nrLogradouro: nrLogradouro,
      dsQuadra: dsQuadra,
      nmLogradouroCompleto: nmLogradouroCompleto,
      nmCidade: nmCidade,
      sgEstado: sgEstado,
      cdTelMovel: cdTelMovel,
      cdTelResidencial: cdTelResidencial,
      dsComplemento: dsComplemento,
    );
