import '/backend/api_requests/api_calls.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'aviso4_widget.dart' show Aviso4Widget;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';

class Aviso4Model extends FlutterFlowModel<Aviso4Widget> {
  ///  State fields for stateful widgets in this component.

  // Stores action output result for [Backend Call - API (Beneficiarios ID Contrato)] action in Button widget.
  ApiCallResponse? apiResultObterDependentes;
  // Stores action output result for [Backend Call - API (SolicitacaoExcluirDependente)] action in Button widget.
  ApiCallResponse? apiResultExcluirDependente;

  @override
  void initState(BuildContext context) {}

  @override
  void dispose() {}
}
