// Automatic FlutterFlow imports
import '/backend/schema/structs/index.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import 'index.dart'; // Imports other custom actions
import '/flutter_flow/custom_functions.dart'; // Imports custom functions
import 'package:flutter/material.dart';
// Begin custom action code
// DO NOT REMOVE OR MODIFY THE CODE ABOVE!

Future<List<String>> getFilesNames(List<FFUploadedFile> files) async {
  List<String> filenames = [];
  for (final file in files) {
    if (file.name != null && file.name!.isNotEmpty) {
      filenames.add(file.name!);
    }
  }
  filenames.removeWhere((elemento) => elemento.isEmpty);
  return filenames;
}
// Set your action name, define your arguments and return parameter,
// and then add the boilerplate code using the green button on the right!
