import '/backend/api_requests/api_calls.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/backend/schema/structs/index.dart';
import '/flutter_flow/custom_functions.dart' as functions;
import 'criar_senha_widget.dart' show CriarSenhaWidget;
import 'package:easy_debounce/easy_debounce.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';

class CriarSenhaModel extends FlutterFlowModel<CriarSenhaWidget> {
  ///  Local state fields for this page.

  bool changed = false;

  ///  State fields for stateful widgets in this page.

  // State field(s) for txtSenha widget.
  FocusNode? txtSenhaFocusNode;
  TextEditingController? txtSenhaTextController;
  late bool txtSenhaVisibility;
  String? Function(BuildContext, String?)? txtSenhaTextControllerValidator;
  // State field(s) for txtConfirmation widget.
  FocusNode? txtConfirmationFocusNode;
  TextEditingController? txtConfirmationTextController;
  late bool txtConfirmationVisibility;
  String? Function(BuildContext, String?)?
      txtConfirmationTextControllerValidator;
  // Stores action output result for [Backend Call - API (addPasswordToNewUser)] action in Button widget.
  ApiCallResponse? updateSenha;

  @override
  void initState(BuildContext context) {
    txtSenhaVisibility = false;
    txtConfirmationVisibility = false;
  }

  @override
  void dispose() {
    txtSenhaFocusNode?.dispose();
    txtSenhaTextController?.dispose();

    txtConfirmationFocusNode?.dispose();
    txtConfirmationTextController?.dispose();
  }
}
