import '/backend/api_requests/api_calls.dart';
import '/backend/schema/structs/index.dart';
import '/components/dependentes_card_widget.dart';
import '/flutter_flow/flutter_flow_icon_button.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'dependentes_widget.dart' show DependentesWidget;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';

class DependentesModel extends FlutterFlowModel<DependentesWidget> {
  ///  State fields for stateful widgets in this page.

  // Models for DependentesCard dynamic component.
  late FlutterFlowDynamicModels<DependentesCardModel> dependentesCardModels;

  @override
  void initState(BuildContext context) {
    dependentesCardModels =
        FlutterFlowDynamicModels(() => DependentesCardModel());
  }

  @override
  void dispose() {
    dependentesCardModels.dispose();
  }
}
