import '/backend/api_requests/api_calls.dart';
import '/backend/schema/structs/index.dart';
import '/components/jazigos_card_widget.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'jazigos_widget.dart' show JazigosWidget;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';

class JazigosModel extends FlutterFlowModel<JazigosWidget> {
  ///  State fields for stateful widgets in this page.

  // Models for JazigosCard dynamic component.
  late FlutterFlowDynamicModels<JazigosCardModel> jazigosCardModels;

  @override
  void initState(BuildContext context) {
    jazigosCardModels = FlutterFlowDynamicModels(() => JazigosCardModel());
  }

  @override
  void dispose() {
    jazigosCardModels.dispose();
  }
}
