import '/backend/schema/structs/index.dart';
import '/components/plano_card_widget.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import 'meus_planos_widget.dart' show MeusPlanosWidget;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';

class MeusPlanosModel extends FlutterFlowModel<MeusPlanosWidget> {
  ///  State fields for stateful widgets in this page.

  // Models for PlanoCard dynamic component.
  late FlutterFlowDynamicModels<PlanoCardModel> planoCardModels;

  @override
  void initState(BuildContext context) {
    planoCardModels = FlutterFlowDynamicModels(() => PlanoCardModel());
  }

  @override
  void dispose() {
    planoCardModels.dispose();
  }
}
