// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class AlteraDependentesDataTypeStruct extends BaseStruct {
  AlteraDependentesDataTypeStruct({
    String? nome,
    String? cpf,
    String? parentesco,
    String? dataNascimento,
  })  : _nome = nome,
        _cpf = cpf,
        _parentesco = parentesco,
        _dataNascimento = dataNascimento;

  // "nome" field.
  String? _nome;
  String get nome => _nome ?? '';
  set nome(String? val) => _nome = val;

  bool hasNome() => _nome != null;

  // "cpf" field.
  String? _cpf;
  String get cpf => _cpf ?? '';
  set cpf(String? val) => _cpf = val;

  bool hasCpf() => _cpf != null;

  // "parentesco" field.
  String? _parentesco;
  String get parentesco => _parentesco ?? '';
  set parentesco(String? val) => _parentesco = val;

  bool hasParentesco() => _parentesco != null;

  // "data_nascimento" field.
  String? _dataNascimento;
  String get dataNascimento => _dataNascimento ?? '';
  set dataNascimento(String? val) => _dataNascimento = val;

  bool hasDataNascimento() => _dataNascimento != null;

  static AlteraDependentesDataTypeStruct fromMap(Map<String, dynamic> data) =>
      AlteraDependentesDataTypeStruct(
        nome: data['nome'] as String?,
        cpf: data['cpf'] as String?,
        parentesco: data['parentesco'] as String?,
        dataNascimento: data['data_nascimento'] as String?,
      );

  static AlteraDependentesDataTypeStruct? maybeFromMap(dynamic data) => data
          is Map
      ? AlteraDependentesDataTypeStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'nome': _nome,
        'cpf': _cpf,
        'parentesco': _parentesco,
        'data_nascimento': _dataNascimento,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'nome': serializeParam(
          _nome,
          ParamType.String,
        ),
        'cpf': serializeParam(
          _cpf,
          ParamType.String,
        ),
        'parentesco': serializeParam(
          _parentesco,
          ParamType.String,
        ),
        'data_nascimento': serializeParam(
          _dataNascimento,
          ParamType.String,
        ),
      }.withoutNulls;

  static AlteraDependentesDataTypeStruct fromSerializableMap(
          Map<String, dynamic> data) =>
      AlteraDependentesDataTypeStruct(
        nome: deserializeParam(
          data['nome'],
          ParamType.String,
          false,
        ),
        cpf: deserializeParam(
          data['cpf'],
          ParamType.String,
          false,
        ),
        parentesco: deserializeParam(
          data['parentesco'],
          ParamType.String,
          false,
        ),
        dataNascimento: deserializeParam(
          data['data_nascimento'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'AlteraDependentesDataTypeStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is AlteraDependentesDataTypeStruct &&
        nome == other.nome &&
        cpf == other.cpf &&
        parentesco == other.parentesco &&
        dataNascimento == other.dataNascimento;
  }

  @override
  int get hashCode =>
      const ListEquality().hash([nome, cpf, parentesco, dataNascimento]);
}

AlteraDependentesDataTypeStruct createAlteraDependentesDataTypeStruct({
  String? nome,
  String? cpf,
  String? parentesco,
  String? dataNascimento,
}) =>
    AlteraDependentesDataTypeStruct(
      nome: nome,
      cpf: cpf,
      parentesco: parentesco,
      dataNascimento: dataNascimento,
    );
