// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class BeneficiarioCadastroDataTypeStruct extends BaseStruct {
  BeneficiarioCadastroDataTypeStruct({
    int? idBeneficiado,
    int? idPessoa,
    int? idContrato,
    String? dtInclusao,
    String? dtCarencia,
    String? aNTCdContrato,
    String? nmGrau,
    String? sgGrau,
    String? aNTCdParentesco,
    String? nmPessoa,
    String? cdCPF,
    String? cdRG,
    String? dtNascimento,
    String? dtFalecimento,
    String? nmReligiao,
    bool? flMasculino,
    int? ddOKCarencia,
    String? dtExcluido,
    String? nmUsuario,
    String? idUsuarioExcluiu,
    int? flAdicional,
    String? nmVinculo,
    String? vrReembolso,
    String? idRespGrupoFamiliar,
    String? ultCartao,
  })  : _idBeneficiado = idBeneficiado,
        _idPessoa = idPessoa,
        _idContrato = idContrato,
        _dtInclusao = dtInclusao,
        _dtCarencia = dtCarencia,
        _aNTCdContrato = aNTCdContrato,
        _nmGrau = nmGrau,
        _sgGrau = sgGrau,
        _aNTCdParentesco = aNTCdParentesco,
        _nmPessoa = nmPessoa,
        _cdCPF = cdCPF,
        _cdRG = cdRG,
        _dtNascimento = dtNascimento,
        _dtFalecimento = dtFalecimento,
        _nmReligiao = nmReligiao,
        _flMasculino = flMasculino,
        _ddOKCarencia = ddOKCarencia,
        _dtExcluido = dtExcluido,
        _nmUsuario = nmUsuario,
        _idUsuarioExcluiu = idUsuarioExcluiu,
        _flAdicional = flAdicional,
        _nmVinculo = nmVinculo,
        _vrReembolso = vrReembolso,
        _idRespGrupoFamiliar = idRespGrupoFamiliar,
        _ultCartao = ultCartao;

  // "idBeneficiado" field.
  int? _idBeneficiado;
  int get idBeneficiado => _idBeneficiado ?? 0;
  set idBeneficiado(int? val) => _idBeneficiado = val;

  void incrementIdBeneficiado(int amount) =>
      idBeneficiado = idBeneficiado + amount;

  bool hasIdBeneficiado() => _idBeneficiado != null;

  // "idPessoa" field.
  int? _idPessoa;
  int get idPessoa => _idPessoa ?? 0;
  set idPessoa(int? val) => _idPessoa = val;

  void incrementIdPessoa(int amount) => idPessoa = idPessoa + amount;

  bool hasIdPessoa() => _idPessoa != null;

  // "idContrato" field.
  int? _idContrato;
  int get idContrato => _idContrato ?? 0;
  set idContrato(int? val) => _idContrato = val;

  void incrementIdContrato(int amount) => idContrato = idContrato + amount;

  bool hasIdContrato() => _idContrato != null;

  // "dtInclusao" field.
  String? _dtInclusao;
  String get dtInclusao => _dtInclusao ?? '';
  set dtInclusao(String? val) => _dtInclusao = val;

  bool hasDtInclusao() => _dtInclusao != null;

  // "dtCarencia" field.
  String? _dtCarencia;
  String get dtCarencia => _dtCarencia ?? '';
  set dtCarencia(String? val) => _dtCarencia = val;

  bool hasDtCarencia() => _dtCarencia != null;

  // "ANT_cdContrato" field.
  String? _aNTCdContrato;
  String get aNTCdContrato => _aNTCdContrato ?? '';
  set aNTCdContrato(String? val) => _aNTCdContrato = val;

  bool hasANTCdContrato() => _aNTCdContrato != null;

  // "nmGrau" field.
  String? _nmGrau;
  String get nmGrau => _nmGrau ?? '';
  set nmGrau(String? val) => _nmGrau = val;

  bool hasNmGrau() => _nmGrau != null;

  // "sgGrau" field.
  String? _sgGrau;
  String get sgGrau => _sgGrau ?? '';
  set sgGrau(String? val) => _sgGrau = val;

  bool hasSgGrau() => _sgGrau != null;

  // "ANT_cdParentesco" field.
  String? _aNTCdParentesco;
  String get aNTCdParentesco => _aNTCdParentesco ?? '';
  set aNTCdParentesco(String? val) => _aNTCdParentesco = val;

  bool hasANTCdParentesco() => _aNTCdParentesco != null;

  // "nmPessoa" field.
  String? _nmPessoa;
  String get nmPessoa => _nmPessoa ?? '';
  set nmPessoa(String? val) => _nmPessoa = val;

  bool hasNmPessoa() => _nmPessoa != null;

  // "cdCPF" field.
  String? _cdCPF;
  String get cdCPF => _cdCPF ?? '';
  set cdCPF(String? val) => _cdCPF = val;

  bool hasCdCPF() => _cdCPF != null;

  // "cdRG" field.
  String? _cdRG;
  String get cdRG => _cdRG ?? '';
  set cdRG(String? val) => _cdRG = val;

  bool hasCdRG() => _cdRG != null;

  // "dtNascimento" field.
  String? _dtNascimento;
  String get dtNascimento => _dtNascimento ?? '';
  set dtNascimento(String? val) => _dtNascimento = val;

  bool hasDtNascimento() => _dtNascimento != null;

  // "dtFalecimento" field.
  String? _dtFalecimento;
  String get dtFalecimento => _dtFalecimento ?? '';
  set dtFalecimento(String? val) => _dtFalecimento = val;

  bool hasDtFalecimento() => _dtFalecimento != null;

  // "nmReligiao" field.
  String? _nmReligiao;
  String get nmReligiao => _nmReligiao ?? '';
  set nmReligiao(String? val) => _nmReligiao = val;

  bool hasNmReligiao() => _nmReligiao != null;

  // "flMasculino" field.
  bool? _flMasculino;
  bool get flMasculino => _flMasculino ?? false;
  set flMasculino(bool? val) => _flMasculino = val;

  bool hasFlMasculino() => _flMasculino != null;

  // "ddOKCarencia" field.
  int? _ddOKCarencia;
  int get ddOKCarencia => _ddOKCarencia ?? 0;
  set ddOKCarencia(int? val) => _ddOKCarencia = val;

  void incrementDdOKCarencia(int amount) =>
      ddOKCarencia = ddOKCarencia + amount;

  bool hasDdOKCarencia() => _ddOKCarencia != null;

  // "dtExcluido" field.
  String? _dtExcluido;
  String get dtExcluido => _dtExcluido ?? '';
  set dtExcluido(String? val) => _dtExcluido = val;

  bool hasDtExcluido() => _dtExcluido != null;

  // "nmUsuario" field.
  String? _nmUsuario;
  String get nmUsuario => _nmUsuario ?? '';
  set nmUsuario(String? val) => _nmUsuario = val;

  bool hasNmUsuario() => _nmUsuario != null;

  // "idUsuarioExcluiu" field.
  String? _idUsuarioExcluiu;
  String get idUsuarioExcluiu => _idUsuarioExcluiu ?? '';
  set idUsuarioExcluiu(String? val) => _idUsuarioExcluiu = val;

  bool hasIdUsuarioExcluiu() => _idUsuarioExcluiu != null;

  // "flAdicional" field.
  int? _flAdicional;
  int get flAdicional => _flAdicional ?? 0;
  set flAdicional(int? val) => _flAdicional = val;

  void incrementFlAdicional(int amount) => flAdicional = flAdicional + amount;

  bool hasFlAdicional() => _flAdicional != null;

  // "nmVinculo" field.
  String? _nmVinculo;
  String get nmVinculo => _nmVinculo ?? '';
  set nmVinculo(String? val) => _nmVinculo = val;

  bool hasNmVinculo() => _nmVinculo != null;

  // "vrReembolso" field.
  String? _vrReembolso;
  String get vrReembolso => _vrReembolso ?? '';
  set vrReembolso(String? val) => _vrReembolso = val;

  bool hasVrReembolso() => _vrReembolso != null;

  // "idRespGrupoFamiliar" field.
  String? _idRespGrupoFamiliar;
  String get idRespGrupoFamiliar => _idRespGrupoFamiliar ?? '';
  set idRespGrupoFamiliar(String? val) => _idRespGrupoFamiliar = val;

  bool hasIdRespGrupoFamiliar() => _idRespGrupoFamiliar != null;

  // "ultCartao" field.
  String? _ultCartao;
  String get ultCartao => _ultCartao ?? '';
  set ultCartao(String? val) => _ultCartao = val;

  bool hasUltCartao() => _ultCartao != null;

  static BeneficiarioCadastroDataTypeStruct fromMap(
          Map<String, dynamic> data) =>
      BeneficiarioCadastroDataTypeStruct(
        idBeneficiado: castToType<int>(data['idBeneficiado']),
        idPessoa: castToType<int>(data['idPessoa']),
        idContrato: castToType<int>(data['idContrato']),
        dtInclusao: data['dtInclusao'] as String?,
        dtCarencia: data['dtCarencia'] as String?,
        aNTCdContrato: data['ANT_cdContrato'] as String?,
        nmGrau: data['nmGrau'] as String?,
        sgGrau: data['sgGrau'] as String?,
        aNTCdParentesco: data['ANT_cdParentesco'] as String?,
        nmPessoa: data['nmPessoa'] as String?,
        cdCPF: data['cdCPF'] as String?,
        cdRG: data['cdRG'] as String?,
        dtNascimento: data['dtNascimento'] as String?,
        dtFalecimento: data['dtFalecimento'] as String?,
        nmReligiao: data['nmReligiao'] as String?,
        flMasculino: data['flMasculino'] as bool?,
        ddOKCarencia: castToType<int>(data['ddOKCarencia']),
        dtExcluido: data['dtExcluido'] as String?,
        nmUsuario: data['nmUsuario'] as String?,
        idUsuarioExcluiu: data['idUsuarioExcluiu'] as String?,
        flAdicional: castToType<int>(data['flAdicional']),
        nmVinculo: data['nmVinculo'] as String?,
        vrReembolso: data['vrReembolso'] as String?,
        idRespGrupoFamiliar: data['idRespGrupoFamiliar'] as String?,
        ultCartao: data['ultCartao'] as String?,
      );

  static BeneficiarioCadastroDataTypeStruct? maybeFromMap(dynamic data) => data
          is Map
      ? BeneficiarioCadastroDataTypeStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'idBeneficiado': _idBeneficiado,
        'idPessoa': _idPessoa,
        'idContrato': _idContrato,
        'dtInclusao': _dtInclusao,
        'dtCarencia': _dtCarencia,
        'ANT_cdContrato': _aNTCdContrato,
        'nmGrau': _nmGrau,
        'sgGrau': _sgGrau,
        'ANT_cdParentesco': _aNTCdParentesco,
        'nmPessoa': _nmPessoa,
        'cdCPF': _cdCPF,
        'cdRG': _cdRG,
        'dtNascimento': _dtNascimento,
        'dtFalecimento': _dtFalecimento,
        'nmReligiao': _nmReligiao,
        'flMasculino': _flMasculino,
        'ddOKCarencia': _ddOKCarencia,
        'dtExcluido': _dtExcluido,
        'nmUsuario': _nmUsuario,
        'idUsuarioExcluiu': _idUsuarioExcluiu,
        'flAdicional': _flAdicional,
        'nmVinculo': _nmVinculo,
        'vrReembolso': _vrReembolso,
        'idRespGrupoFamiliar': _idRespGrupoFamiliar,
        'ultCartao': _ultCartao,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'idBeneficiado': serializeParam(
          _idBeneficiado,
          ParamType.int,
        ),
        'idPessoa': serializeParam(
          _idPessoa,
          ParamType.int,
        ),
        'idContrato': serializeParam(
          _idContrato,
          ParamType.int,
        ),
        'dtInclusao': serializeParam(
          _dtInclusao,
          ParamType.String,
        ),
        'dtCarencia': serializeParam(
          _dtCarencia,
          ParamType.String,
        ),
        'ANT_cdContrato': serializeParam(
          _aNTCdContrato,
          ParamType.String,
        ),
        'nmGrau': serializeParam(
          _nmGrau,
          ParamType.String,
        ),
        'sgGrau': serializeParam(
          _sgGrau,
          ParamType.String,
        ),
        'ANT_cdParentesco': serializeParam(
          _aNTCdParentesco,
          ParamType.String,
        ),
        'nmPessoa': serializeParam(
          _nmPessoa,
          ParamType.String,
        ),
        'cdCPF': serializeParam(
          _cdCPF,
          ParamType.String,
        ),
        'cdRG': serializeParam(
          _cdRG,
          ParamType.String,
        ),
        'dtNascimento': serializeParam(
          _dtNascimento,
          ParamType.String,
        ),
        'dtFalecimento': serializeParam(
          _dtFalecimento,
          ParamType.String,
        ),
        'nmReligiao': serializeParam(
          _nmReligiao,
          ParamType.String,
        ),
        'flMasculino': serializeParam(
          _flMasculino,
          ParamType.bool,
        ),
        'ddOKCarencia': serializeParam(
          _ddOKCarencia,
          ParamType.int,
        ),
        'dtExcluido': serializeParam(
          _dtExcluido,
          ParamType.String,
        ),
        'nmUsuario': serializeParam(
          _nmUsuario,
          ParamType.String,
        ),
        'idUsuarioExcluiu': serializeParam(
          _idUsuarioExcluiu,
          ParamType.String,
        ),
        'flAdicional': serializeParam(
          _flAdicional,
          ParamType.int,
        ),
        'nmVinculo': serializeParam(
          _nmVinculo,
          ParamType.String,
        ),
        'vrReembolso': serializeParam(
          _vrReembolso,
          ParamType.String,
        ),
        'idRespGrupoFamiliar': serializeParam(
          _idRespGrupoFamiliar,
          ParamType.String,
        ),
        'ultCartao': serializeParam(
          _ultCartao,
          ParamType.String,
        ),
      }.withoutNulls;

  static BeneficiarioCadastroDataTypeStruct fromSerializableMap(
          Map<String, dynamic> data) =>
      BeneficiarioCadastroDataTypeStruct(
        idBeneficiado: deserializeParam(
          data['idBeneficiado'],
          ParamType.int,
          false,
        ),
        idPessoa: deserializeParam(
          data['idPessoa'],
          ParamType.int,
          false,
        ),
        idContrato: deserializeParam(
          data['idContrato'],
          ParamType.int,
          false,
        ),
        dtInclusao: deserializeParam(
          data['dtInclusao'],
          ParamType.String,
          false,
        ),
        dtCarencia: deserializeParam(
          data['dtCarencia'],
          ParamType.String,
          false,
        ),
        aNTCdContrato: deserializeParam(
          data['ANT_cdContrato'],
          ParamType.String,
          false,
        ),
        nmGrau: deserializeParam(
          data['nmGrau'],
          ParamType.String,
          false,
        ),
        sgGrau: deserializeParam(
          data['sgGrau'],
          ParamType.String,
          false,
        ),
        aNTCdParentesco: deserializeParam(
          data['ANT_cdParentesco'],
          ParamType.String,
          false,
        ),
        nmPessoa: deserializeParam(
          data['nmPessoa'],
          ParamType.String,
          false,
        ),
        cdCPF: deserializeParam(
          data['cdCPF'],
          ParamType.String,
          false,
        ),
        cdRG: deserializeParam(
          data['cdRG'],
          ParamType.String,
          false,
        ),
        dtNascimento: deserializeParam(
          data['dtNascimento'],
          ParamType.String,
          false,
        ),
        dtFalecimento: deserializeParam(
          data['dtFalecimento'],
          ParamType.String,
          false,
        ),
        nmReligiao: deserializeParam(
          data['nmReligiao'],
          ParamType.String,
          false,
        ),
        flMasculino: deserializeParam(
          data['flMasculino'],
          ParamType.bool,
          false,
        ),
        ddOKCarencia: deserializeParam(
          data['ddOKCarencia'],
          ParamType.int,
          false,
        ),
        dtExcluido: deserializeParam(
          data['dtExcluido'],
          ParamType.String,
          false,
        ),
        nmUsuario: deserializeParam(
          data['nmUsuario'],
          ParamType.String,
          false,
        ),
        idUsuarioExcluiu: deserializeParam(
          data['idUsuarioExcluiu'],
          ParamType.String,
          false,
        ),
        flAdicional: deserializeParam(
          data['flAdicional'],
          ParamType.int,
          false,
        ),
        nmVinculo: deserializeParam(
          data['nmVinculo'],
          ParamType.String,
          false,
        ),
        vrReembolso: deserializeParam(
          data['vrReembolso'],
          ParamType.String,
          false,
        ),
        idRespGrupoFamiliar: deserializeParam(
          data['idRespGrupoFamiliar'],
          ParamType.String,
          false,
        ),
        ultCartao: deserializeParam(
          data['ultCartao'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'BeneficiarioCadastroDataTypeStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is BeneficiarioCadastroDataTypeStruct &&
        idBeneficiado == other.idBeneficiado &&
        idPessoa == other.idPessoa &&
        idContrato == other.idContrato &&
        dtInclusao == other.dtInclusao &&
        dtCarencia == other.dtCarencia &&
        aNTCdContrato == other.aNTCdContrato &&
        nmGrau == other.nmGrau &&
        sgGrau == other.sgGrau &&
        aNTCdParentesco == other.aNTCdParentesco &&
        nmPessoa == other.nmPessoa &&
        cdCPF == other.cdCPF &&
        cdRG == other.cdRG &&
        dtNascimento == other.dtNascimento &&
        dtFalecimento == other.dtFalecimento &&
        nmReligiao == other.nmReligiao &&
        flMasculino == other.flMasculino &&
        ddOKCarencia == other.ddOKCarencia &&
        dtExcluido == other.dtExcluido &&
        nmUsuario == other.nmUsuario &&
        idUsuarioExcluiu == other.idUsuarioExcluiu &&
        flAdicional == other.flAdicional &&
        nmVinculo == other.nmVinculo &&
        vrReembolso == other.vrReembolso &&
        idRespGrupoFamiliar == other.idRespGrupoFamiliar &&
        ultCartao == other.ultCartao;
  }

  @override
  int get hashCode => const ListEquality().hash([
        idBeneficiado,
        idPessoa,
        idContrato,
        dtInclusao,
        dtCarencia,
        aNTCdContrato,
        nmGrau,
        sgGrau,
        aNTCdParentesco,
        nmPessoa,
        cdCPF,
        cdRG,
        dtNascimento,
        dtFalecimento,
        nmReligiao,
        flMasculino,
        ddOKCarencia,
        dtExcluido,
        nmUsuario,
        idUsuarioExcluiu,
        flAdicional,
        nmVinculo,
        vrReembolso,
        idRespGrupoFamiliar,
        ultCartao
      ]);
}

BeneficiarioCadastroDataTypeStruct createBeneficiarioCadastroDataTypeStruct({
  int? idBeneficiado,
  int? idPessoa,
  int? idContrato,
  String? dtInclusao,
  String? dtCarencia,
  String? aNTCdContrato,
  String? nmGrau,
  String? sgGrau,
  String? aNTCdParentesco,
  String? nmPessoa,
  String? cdCPF,
  String? cdRG,
  String? dtNascimento,
  String? dtFalecimento,
  String? nmReligiao,
  bool? flMasculino,
  int? ddOKCarencia,
  String? dtExcluido,
  String? nmUsuario,
  String? idUsuarioExcluiu,
  int? flAdicional,
  String? nmVinculo,
  String? vrReembolso,
  String? idRespGrupoFamiliar,
  String? ultCartao,
}) =>
    BeneficiarioCadastroDataTypeStruct(
      idBeneficiado: idBeneficiado,
      idPessoa: idPessoa,
      idContrato: idContrato,
      dtInclusao: dtInclusao,
      dtCarencia: dtCarencia,
      aNTCdContrato: aNTCdContrato,
      nmGrau: nmGrau,
      sgGrau: sgGrau,
      aNTCdParentesco: aNTCdParentesco,
      nmPessoa: nmPessoa,
      cdCPF: cdCPF,
      cdRG: cdRG,
      dtNascimento: dtNascimento,
      dtFalecimento: dtFalecimento,
      nmReligiao: nmReligiao,
      flMasculino: flMasculino,
      ddOKCarencia: ddOKCarencia,
      dtExcluido: dtExcluido,
      nmUsuario: nmUsuario,
      idUsuarioExcluiu: idUsuarioExcluiu,
      flAdicional: flAdicional,
      nmVinculo: nmVinculo,
      vrReembolso: vrReembolso,
      idRespGrupoFamiliar: idRespGrupoFamiliar,
      ultCartao: ultCartao,
    );
