// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class BeneficiarioStruct extends BaseStruct {
  BeneficiarioStruct({
    int? idPessoa,
    int? idContrato,
    String? nmPessoa,
    String? nmGenero,
    String? dtNascimento,
    String? cdCpf,
    String? nmBairro,
    String? nmCidade,
    String? sgEstado,
    String? nmCobertura,
    String? dtProximaGeracao,
    String? dtAdesao,
    String? dtVenda,
    String? sgGrau,
    String? idLamina,
    String? nmLamina,
    String? lsLaminasContrato,
  })  : _idPessoa = idPessoa,
        _idContrato = idContrato,
        _nmPessoa = nmPessoa,
        _nmGenero = nmGenero,
        _dtNascimento = dtNascimento,
        _cdCpf = cdCpf,
        _nmBairro = nmBairro,
        _nmCidade = nmCidade,
        _sgEstado = sgEstado,
        _nmCobertura = nmCobertura,
        _dtProximaGeracao = dtProximaGeracao,
        _dtAdesao = dtAdesao,
        _dtVenda = dtVenda,
        _sgGrau = sgGrau,
        _idLamina = idLamina,
        _nmLamina = nmLamina,
        _lsLaminasContrato = lsLaminasContrato;

  // "idPessoa" field.
  int? _idPessoa;
  int get idPessoa => _idPessoa ?? 0;
  set idPessoa(int? val) => _idPessoa = val;

  void incrementIdPessoa(int amount) => idPessoa = idPessoa + amount;

  bool hasIdPessoa() => _idPessoa != null;

  // "idContrato" field.
  int? _idContrato;
  int get idContrato => _idContrato ?? 0;
  set idContrato(int? val) => _idContrato = val;

  void incrementIdContrato(int amount) => idContrato = idContrato + amount;

  bool hasIdContrato() => _idContrato != null;

  // "nmPessoa" field.
  String? _nmPessoa;
  String get nmPessoa => _nmPessoa ?? '';
  set nmPessoa(String? val) => _nmPessoa = val;

  bool hasNmPessoa() => _nmPessoa != null;

  // "nmGenero" field.
  String? _nmGenero;
  String get nmGenero => _nmGenero ?? '';
  set nmGenero(String? val) => _nmGenero = val;

  bool hasNmGenero() => _nmGenero != null;

  // "dtNascimento" field.
  String? _dtNascimento;
  String get dtNascimento => _dtNascimento ?? '';
  set dtNascimento(String? val) => _dtNascimento = val;

  bool hasDtNascimento() => _dtNascimento != null;

  // "cdCpf" field.
  String? _cdCpf;
  String get cdCpf => _cdCpf ?? '';
  set cdCpf(String? val) => _cdCpf = val;

  bool hasCdCpf() => _cdCpf != null;

  // "nmBairro" field.
  String? _nmBairro;
  String get nmBairro => _nmBairro ?? '';
  set nmBairro(String? val) => _nmBairro = val;

  bool hasNmBairro() => _nmBairro != null;

  // "nmCidade" field.
  String? _nmCidade;
  String get nmCidade => _nmCidade ?? '';
  set nmCidade(String? val) => _nmCidade = val;

  bool hasNmCidade() => _nmCidade != null;

  // "sgEstado" field.
  String? _sgEstado;
  String get sgEstado => _sgEstado ?? '';
  set sgEstado(String? val) => _sgEstado = val;

  bool hasSgEstado() => _sgEstado != null;

  // "nmCobertura" field.
  String? _nmCobertura;
  String get nmCobertura => _nmCobertura ?? '';
  set nmCobertura(String? val) => _nmCobertura = val;

  bool hasNmCobertura() => _nmCobertura != null;

  // "dtProximaGeracao" field.
  String? _dtProximaGeracao;
  String get dtProximaGeracao => _dtProximaGeracao ?? '';
  set dtProximaGeracao(String? val) => _dtProximaGeracao = val;

  bool hasDtProximaGeracao() => _dtProximaGeracao != null;

  // "dtAdesao" field.
  String? _dtAdesao;
  String get dtAdesao => _dtAdesao ?? '';
  set dtAdesao(String? val) => _dtAdesao = val;

  bool hasDtAdesao() => _dtAdesao != null;

  // "dtVenda" field.
  String? _dtVenda;
  String get dtVenda => _dtVenda ?? '';
  set dtVenda(String? val) => _dtVenda = val;

  bool hasDtVenda() => _dtVenda != null;

  // "sgGrau" field.
  String? _sgGrau;
  String get sgGrau => _sgGrau ?? '';
  set sgGrau(String? val) => _sgGrau = val;

  bool hasSgGrau() => _sgGrau != null;

  // "idLamina" field.
  String? _idLamina;
  String get idLamina => _idLamina ?? '';
  set idLamina(String? val) => _idLamina = val;

  bool hasIdLamina() => _idLamina != null;

  // "nmLamina" field.
  String? _nmLamina;
  String get nmLamina => _nmLamina ?? '';
  set nmLamina(String? val) => _nmLamina = val;

  bool hasNmLamina() => _nmLamina != null;

  // "lsLaminasContrato" field.
  String? _lsLaminasContrato;
  String get lsLaminasContrato => _lsLaminasContrato ?? '';
  set lsLaminasContrato(String? val) => _lsLaminasContrato = val;

  bool hasLsLaminasContrato() => _lsLaminasContrato != null;

  static BeneficiarioStruct fromMap(Map<String, dynamic> data) =>
      BeneficiarioStruct(
        idPessoa: castToType<int>(data['idPessoa']),
        idContrato: castToType<int>(data['idContrato']),
        nmPessoa: data['nmPessoa'] as String?,
        nmGenero: data['nmGenero'] as String?,
        dtNascimento: data['dtNascimento'] as String?,
        cdCpf: data['cdCpf'] as String?,
        nmBairro: data['nmBairro'] as String?,
        nmCidade: data['nmCidade'] as String?,
        sgEstado: data['sgEstado'] as String?,
        nmCobertura: data['nmCobertura'] as String?,
        dtProximaGeracao: data['dtProximaGeracao'] as String?,
        dtAdesao: data['dtAdesao'] as String?,
        dtVenda: data['dtVenda'] as String?,
        sgGrau: data['sgGrau'] as String?,
        idLamina: data['idLamina'] as String?,
        nmLamina: data['nmLamina'] as String?,
        lsLaminasContrato: data['lsLaminasContrato'] as String?,
      );

  static BeneficiarioStruct? maybeFromMap(dynamic data) => data is Map
      ? BeneficiarioStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'idPessoa': _idPessoa,
        'idContrato': _idContrato,
        'nmPessoa': _nmPessoa,
        'nmGenero': _nmGenero,
        'dtNascimento': _dtNascimento,
        'cdCpf': _cdCpf,
        'nmBairro': _nmBairro,
        'nmCidade': _nmCidade,
        'sgEstado': _sgEstado,
        'nmCobertura': _nmCobertura,
        'dtProximaGeracao': _dtProximaGeracao,
        'dtAdesao': _dtAdesao,
        'dtVenda': _dtVenda,
        'sgGrau': _sgGrau,
        'idLamina': _idLamina,
        'nmLamina': _nmLamina,
        'lsLaminasContrato': _lsLaminasContrato,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'idPessoa': serializeParam(
          _idPessoa,
          ParamType.int,
        ),
        'idContrato': serializeParam(
          _idContrato,
          ParamType.int,
        ),
        'nmPessoa': serializeParam(
          _nmPessoa,
          ParamType.String,
        ),
        'nmGenero': serializeParam(
          _nmGenero,
          ParamType.String,
        ),
        'dtNascimento': serializeParam(
          _dtNascimento,
          ParamType.String,
        ),
        'cdCpf': serializeParam(
          _cdCpf,
          ParamType.String,
        ),
        'nmBairro': serializeParam(
          _nmBairro,
          ParamType.String,
        ),
        'nmCidade': serializeParam(
          _nmCidade,
          ParamType.String,
        ),
        'sgEstado': serializeParam(
          _sgEstado,
          ParamType.String,
        ),
        'nmCobertura': serializeParam(
          _nmCobertura,
          ParamType.String,
        ),
        'dtProximaGeracao': serializeParam(
          _dtProximaGeracao,
          ParamType.String,
        ),
        'dtAdesao': serializeParam(
          _dtAdesao,
          ParamType.String,
        ),
        'dtVenda': serializeParam(
          _dtVenda,
          ParamType.String,
        ),
        'sgGrau': serializeParam(
          _sgGrau,
          ParamType.String,
        ),
        'idLamina': serializeParam(
          _idLamina,
          ParamType.String,
        ),
        'nmLamina': serializeParam(
          _nmLamina,
          ParamType.String,
        ),
        'lsLaminasContrato': serializeParam(
          _lsLaminasContrato,
          ParamType.String,
        ),
      }.withoutNulls;

  static BeneficiarioStruct fromSerializableMap(Map<String, dynamic> data) =>
      BeneficiarioStruct(
        idPessoa: deserializeParam(
          data['idPessoa'],
          ParamType.int,
          false,
        ),
        idContrato: deserializeParam(
          data['idContrato'],
          ParamType.int,
          false,
        ),
        nmPessoa: deserializeParam(
          data['nmPessoa'],
          ParamType.String,
          false,
        ),
        nmGenero: deserializeParam(
          data['nmGenero'],
          ParamType.String,
          false,
        ),
        dtNascimento: deserializeParam(
          data['dtNascimento'],
          ParamType.String,
          false,
        ),
        cdCpf: deserializeParam(
          data['cdCpf'],
          ParamType.String,
          false,
        ),
        nmBairro: deserializeParam(
          data['nmBairro'],
          ParamType.String,
          false,
        ),
        nmCidade: deserializeParam(
          data['nmCidade'],
          ParamType.String,
          false,
        ),
        sgEstado: deserializeParam(
          data['sgEstado'],
          ParamType.String,
          false,
        ),
        nmCobertura: deserializeParam(
          data['nmCobertura'],
          ParamType.String,
          false,
        ),
        dtProximaGeracao: deserializeParam(
          data['dtProximaGeracao'],
          ParamType.String,
          false,
        ),
        dtAdesao: deserializeParam(
          data['dtAdesao'],
          ParamType.String,
          false,
        ),
        dtVenda: deserializeParam(
          data['dtVenda'],
          ParamType.String,
          false,
        ),
        sgGrau: deserializeParam(
          data['sgGrau'],
          ParamType.String,
          false,
        ),
        idLamina: deserializeParam(
          data['idLamina'],
          ParamType.String,
          false,
        ),
        nmLamina: deserializeParam(
          data['nmLamina'],
          ParamType.String,
          false,
        ),
        lsLaminasContrato: deserializeParam(
          data['lsLaminasContrato'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'BeneficiarioStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is BeneficiarioStruct &&
        idPessoa == other.idPessoa &&
        idContrato == other.idContrato &&
        nmPessoa == other.nmPessoa &&
        nmGenero == other.nmGenero &&
        dtNascimento == other.dtNascimento &&
        cdCpf == other.cdCpf &&
        nmBairro == other.nmBairro &&
        nmCidade == other.nmCidade &&
        sgEstado == other.sgEstado &&
        nmCobertura == other.nmCobertura &&
        dtProximaGeracao == other.dtProximaGeracao &&
        dtAdesao == other.dtAdesao &&
        dtVenda == other.dtVenda &&
        sgGrau == other.sgGrau &&
        idLamina == other.idLamina &&
        nmLamina == other.nmLamina &&
        lsLaminasContrato == other.lsLaminasContrato;
  }

  @override
  int get hashCode => const ListEquality().hash([
        idPessoa,
        idContrato,
        nmPessoa,
        nmGenero,
        dtNascimento,
        cdCpf,
        nmBairro,
        nmCidade,
        sgEstado,
        nmCobertura,
        dtProximaGeracao,
        dtAdesao,
        dtVenda,
        sgGrau,
        idLamina,
        nmLamina,
        lsLaminasContrato
      ]);
}

BeneficiarioStruct createBeneficiarioStruct({
  int? idPessoa,
  int? idContrato,
  String? nmPessoa,
  String? nmGenero,
  String? dtNascimento,
  String? cdCpf,
  String? nmBairro,
  String? nmCidade,
  String? sgEstado,
  String? nmCobertura,
  String? dtProximaGeracao,
  String? dtAdesao,
  String? dtVenda,
  String? sgGrau,
  String? idLamina,
  String? nmLamina,
  String? lsLaminasContrato,
}) =>
    BeneficiarioStruct(
      idPessoa: idPessoa,
      idContrato: idContrato,
      nmPessoa: nmPessoa,
      nmGenero: nmGenero,
      dtNascimento: dtNascimento,
      cdCpf: cdCpf,
      nmBairro: nmBairro,
      nmCidade: nmCidade,
      sgEstado: sgEstado,
      nmCobertura: nmCobertura,
      dtProximaGeracao: dtProximaGeracao,
      dtAdesao: dtAdesao,
      dtVenda: dtVenda,
      sgGrau: sgGrau,
      idLamina: idLamina,
      nmLamina: nmLamina,
      lsLaminasContrato: lsLaminasContrato,
    );
