// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class DecodedTokenStruct extends BaseStruct {
  DecodedTokenStruct({
    SubStruct? sub,
  }) : _sub = sub;

  // "sub" field.
  SubStruct? _sub;
  SubStruct get sub => _sub ?? SubStruct();
  set sub(SubStruct? val) => _sub = val;

  void updateSub(Function(SubStruct) updateFn) {
    updateFn(_sub ??= SubStruct());
  }

  bool hasSub() => _sub != null;

  static DecodedTokenStruct fromMap(Map<String, dynamic> data) =>
      DecodedTokenStruct(
        sub: data['sub'] is SubStruct
            ? data['sub']
            : SubStruct.maybeFromMap(data['sub']),
      );

  static DecodedTokenStruct? maybeFromMap(dynamic data) => data is Map
      ? DecodedTokenStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'sub': _sub?.toMap(),
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'sub': serializeParam(
          _sub,
          ParamType.DataStruct,
        ),
      }.withoutNulls;

  static DecodedTokenStruct fromSerializableMap(Map<String, dynamic> data) =>
      DecodedTokenStruct(
        sub: deserializeStructParam(
          data['sub'],
          ParamType.DataStruct,
          false,
          structBuilder: SubStruct.fromSerializableMap,
        ),
      );

  @override
  String toString() => 'DecodedTokenStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is DecodedTokenStruct && sub == other.sub;
  }

  @override
  int get hashCode => const ListEquality().hash([sub]);
}

DecodedTokenStruct createDecodedTokenStruct({
  SubStruct? sub,
}) =>
    DecodedTokenStruct(
      sub: sub ?? SubStruct(),
    );
