// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class JazigosDataTypeStruct extends BaseStruct {
  JazigosDataTypeStruct({
    int? idAssentamento,
    String? nmTipoLoculo,
    String? cdLoculo,
    String? nmAssentado,
    String? cdEstadoCivil,
    String? dtSepultamento,
    String? hrSepultamento,
    String? dtNascimento,
    String? sexo,
    String? cdReligiao,
    String? dtObito,
    String? hrObito,
    int? idContrato,
    String? nmTitular,
  })  : _idAssentamento = idAssentamento,
        _nmTipoLoculo = nmTipoLoculo,
        _cdLoculo = cdLoculo,
        _nmAssentado = nmAssentado,
        _cdEstadoCivil = cdEstadoCivil,
        _dtSepultamento = dtSepultamento,
        _hrSepultamento = hrSepultamento,
        _dtNascimento = dtNascimento,
        _sexo = sexo,
        _cdReligiao = cdReligiao,
        _dtObito = dtObito,
        _hrObito = hrObito,
        _idContrato = idContrato,
        _nmTitular = nmTitular;

  // "idAssentamento" field.
  int? _idAssentamento;
  int get idAssentamento => _idAssentamento ?? 0;
  set idAssentamento(int? val) => _idAssentamento = val;

  void incrementIdAssentamento(int amount) =>
      idAssentamento = idAssentamento + amount;

  bool hasIdAssentamento() => _idAssentamento != null;

  // "nmTipoLoculo" field.
  String? _nmTipoLoculo;
  String get nmTipoLoculo => _nmTipoLoculo ?? '';
  set nmTipoLoculo(String? val) => _nmTipoLoculo = val;

  bool hasNmTipoLoculo() => _nmTipoLoculo != null;

  // "cdLoculo" field.
  String? _cdLoculo;
  String get cdLoculo => _cdLoculo ?? '';
  set cdLoculo(String? val) => _cdLoculo = val;

  bool hasCdLoculo() => _cdLoculo != null;

  // "nmAssentado" field.
  String? _nmAssentado;
  String get nmAssentado => _nmAssentado ?? '';
  set nmAssentado(String? val) => _nmAssentado = val;

  bool hasNmAssentado() => _nmAssentado != null;

  // "cdEstadoCivil" field.
  String? _cdEstadoCivil;
  String get cdEstadoCivil => _cdEstadoCivil ?? '';
  set cdEstadoCivil(String? val) => _cdEstadoCivil = val;

  bool hasCdEstadoCivil() => _cdEstadoCivil != null;

  // "dtSepultamento" field.
  String? _dtSepultamento;
  String get dtSepultamento => _dtSepultamento ?? '';
  set dtSepultamento(String? val) => _dtSepultamento = val;

  bool hasDtSepultamento() => _dtSepultamento != null;

  // "hrSepultamento" field.
  String? _hrSepultamento;
  String get hrSepultamento => _hrSepultamento ?? '';
  set hrSepultamento(String? val) => _hrSepultamento = val;

  bool hasHrSepultamento() => _hrSepultamento != null;

  // "dtNascimento" field.
  String? _dtNascimento;
  String get dtNascimento => _dtNascimento ?? '';
  set dtNascimento(String? val) => _dtNascimento = val;

  bool hasDtNascimento() => _dtNascimento != null;

  // "sexo" field.
  String? _sexo;
  String get sexo => _sexo ?? '';
  set sexo(String? val) => _sexo = val;

  bool hasSexo() => _sexo != null;

  // "cdReligiao" field.
  String? _cdReligiao;
  String get cdReligiao => _cdReligiao ?? '';
  set cdReligiao(String? val) => _cdReligiao = val;

  bool hasCdReligiao() => _cdReligiao != null;

  // "dtObito" field.
  String? _dtObito;
  String get dtObito => _dtObito ?? '';
  set dtObito(String? val) => _dtObito = val;

  bool hasDtObito() => _dtObito != null;

  // "hrObito" field.
  String? _hrObito;
  String get hrObito => _hrObito ?? '';
  set hrObito(String? val) => _hrObito = val;

  bool hasHrObito() => _hrObito != null;

  // "idContrato" field.
  int? _idContrato;
  int get idContrato => _idContrato ?? 0;
  set idContrato(int? val) => _idContrato = val;

  void incrementIdContrato(int amount) => idContrato = idContrato + amount;

  bool hasIdContrato() => _idContrato != null;

  // "nmTitular" field.
  String? _nmTitular;
  String get nmTitular => _nmTitular ?? '';
  set nmTitular(String? val) => _nmTitular = val;

  bool hasNmTitular() => _nmTitular != null;

  static JazigosDataTypeStruct fromMap(Map<String, dynamic> data) =>
      JazigosDataTypeStruct(
        idAssentamento: castToType<int>(data['idAssentamento']),
        nmTipoLoculo: data['nmTipoLoculo'] as String?,
        cdLoculo: data['cdLoculo'] as String?,
        nmAssentado: data['nmAssentado'] as String?,
        cdEstadoCivil: data['cdEstadoCivil'] as String?,
        dtSepultamento: data['dtSepultamento'] as String?,
        hrSepultamento: data['hrSepultamento'] as String?,
        dtNascimento: data['dtNascimento'] as String?,
        sexo: data['sexo'] as String?,
        cdReligiao: data['cdReligiao'] as String?,
        dtObito: data['dtObito'] as String?,
        hrObito: data['hrObito'] as String?,
        idContrato: castToType<int>(data['idContrato']),
        nmTitular: data['nmTitular'] as String?,
      );

  static JazigosDataTypeStruct? maybeFromMap(dynamic data) => data is Map
      ? JazigosDataTypeStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'idAssentamento': _idAssentamento,
        'nmTipoLoculo': _nmTipoLoculo,
        'cdLoculo': _cdLoculo,
        'nmAssentado': _nmAssentado,
        'cdEstadoCivil': _cdEstadoCivil,
        'dtSepultamento': _dtSepultamento,
        'hrSepultamento': _hrSepultamento,
        'dtNascimento': _dtNascimento,
        'sexo': _sexo,
        'cdReligiao': _cdReligiao,
        'dtObito': _dtObito,
        'hrObito': _hrObito,
        'idContrato': _idContrato,
        'nmTitular': _nmTitular,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'idAssentamento': serializeParam(
          _idAssentamento,
          ParamType.int,
        ),
        'nmTipoLoculo': serializeParam(
          _nmTipoLoculo,
          ParamType.String,
        ),
        'cdLoculo': serializeParam(
          _cdLoculo,
          ParamType.String,
        ),
        'nmAssentado': serializeParam(
          _nmAssentado,
          ParamType.String,
        ),
        'cdEstadoCivil': serializeParam(
          _cdEstadoCivil,
          ParamType.String,
        ),
        'dtSepultamento': serializeParam(
          _dtSepultamento,
          ParamType.String,
        ),
        'hrSepultamento': serializeParam(
          _hrSepultamento,
          ParamType.String,
        ),
        'dtNascimento': serializeParam(
          _dtNascimento,
          ParamType.String,
        ),
        'sexo': serializeParam(
          _sexo,
          ParamType.String,
        ),
        'cdReligiao': serializeParam(
          _cdReligiao,
          ParamType.String,
        ),
        'dtObito': serializeParam(
          _dtObito,
          ParamType.String,
        ),
        'hrObito': serializeParam(
          _hrObito,
          ParamType.String,
        ),
        'idContrato': serializeParam(
          _idContrato,
          ParamType.int,
        ),
        'nmTitular': serializeParam(
          _nmTitular,
          ParamType.String,
        ),
      }.withoutNulls;

  static JazigosDataTypeStruct fromSerializableMap(Map<String, dynamic> data) =>
      JazigosDataTypeStruct(
        idAssentamento: deserializeParam(
          data['idAssentamento'],
          ParamType.int,
          false,
        ),
        nmTipoLoculo: deserializeParam(
          data['nmTipoLoculo'],
          ParamType.String,
          false,
        ),
        cdLoculo: deserializeParam(
          data['cdLoculo'],
          ParamType.String,
          false,
        ),
        nmAssentado: deserializeParam(
          data['nmAssentado'],
          ParamType.String,
          false,
        ),
        cdEstadoCivil: deserializeParam(
          data['cdEstadoCivil'],
          ParamType.String,
          false,
        ),
        dtSepultamento: deserializeParam(
          data['dtSepultamento'],
          ParamType.String,
          false,
        ),
        hrSepultamento: deserializeParam(
          data['hrSepultamento'],
          ParamType.String,
          false,
        ),
        dtNascimento: deserializeParam(
          data['dtNascimento'],
          ParamType.String,
          false,
        ),
        sexo: deserializeParam(
          data['sexo'],
          ParamType.String,
          false,
        ),
        cdReligiao: deserializeParam(
          data['cdReligiao'],
          ParamType.String,
          false,
        ),
        dtObito: deserializeParam(
          data['dtObito'],
          ParamType.String,
          false,
        ),
        hrObito: deserializeParam(
          data['hrObito'],
          ParamType.String,
          false,
        ),
        idContrato: deserializeParam(
          data['idContrato'],
          ParamType.int,
          false,
        ),
        nmTitular: deserializeParam(
          data['nmTitular'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'JazigosDataTypeStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is JazigosDataTypeStruct &&
        idAssentamento == other.idAssentamento &&
        nmTipoLoculo == other.nmTipoLoculo &&
        cdLoculo == other.cdLoculo &&
        nmAssentado == other.nmAssentado &&
        cdEstadoCivil == other.cdEstadoCivil &&
        dtSepultamento == other.dtSepultamento &&
        hrSepultamento == other.hrSepultamento &&
        dtNascimento == other.dtNascimento &&
        sexo == other.sexo &&
        cdReligiao == other.cdReligiao &&
        dtObito == other.dtObito &&
        hrObito == other.hrObito &&
        idContrato == other.idContrato &&
        nmTitular == other.nmTitular;
  }

  @override
  int get hashCode => const ListEquality().hash([
        idAssentamento,
        nmTipoLoculo,
        cdLoculo,
        nmAssentado,
        cdEstadoCivil,
        dtSepultamento,
        hrSepultamento,
        dtNascimento,
        sexo,
        cdReligiao,
        dtObito,
        hrObito,
        idContrato,
        nmTitular
      ]);
}

JazigosDataTypeStruct createJazigosDataTypeStruct({
  int? idAssentamento,
  String? nmTipoLoculo,
  String? cdLoculo,
  String? nmAssentado,
  String? cdEstadoCivil,
  String? dtSepultamento,
  String? hrSepultamento,
  String? dtNascimento,
  String? sexo,
  String? cdReligiao,
  String? dtObito,
  String? hrObito,
  int? idContrato,
  String? nmTitular,
}) =>
    JazigosDataTypeStruct(
      idAssentamento: idAssentamento,
      nmTipoLoculo: nmTipoLoculo,
      cdLoculo: cdLoculo,
      nmAssentado: nmAssentado,
      cdEstadoCivil: cdEstadoCivil,
      dtSepultamento: dtSepultamento,
      hrSepultamento: hrSepultamento,
      dtNascimento: dtNascimento,
      sexo: sexo,
      cdReligiao: cdReligiao,
      dtObito: dtObito,
      hrObito: hrObito,
      idContrato: idContrato,
      nmTitular: nmTitular,
    );
