import '/backend/api_requests/api_calls.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'adicionar_representante_widget.dart' show AdicionarRepresentanteWidget;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:mask_text_input_formatter/mask_text_input_formatter.dart';
import 'package:provider/provider.dart';

class AdicionarRepresentanteModel
    extends FlutterFlowModel<AdicionarRepresentanteWidget> {
  ///  State fields for stateful widgets in this page.

  // State field(s) for txtCpf widget.
  FocusNode? txtCpfFocusNode;
  TextEditingController? txtCpfTextController;
  final txtCpfMask = MaskTextInputFormatter(mask: '###.###.###-##');
  String? Function(BuildContext, String?)? txtCpfTextControllerValidator;
  // State field(s) for txtDataNasc widget.
  FocusNode? txtDataNascFocusNode;
  TextEditingController? txtDataNascTextController;
  final txtDataNascMask = MaskTextInputFormatter(mask: '##/##/####');
  String? Function(BuildContext, String?)? txtDataNascTextControllerValidator;
  // Stores action output result for [Backend Call - API (Consulta Planos Beneficiario Por CPF e Data Nascimento)] action in Button widget.
  ApiCallResponse? apiResultyzh;
  // Stores action output result for [Backend Call - API (Beneficiarios ID Contrato)] action in Button widget.
  ApiCallResponse? apiResult3m5;
  // Stores action output result for [Backend Call - API (addRepresentante)] action in Button widget.
  ApiCallResponse? apiResulty7l;
  // Stores action output result for [Backend Call - API (getRepresentantes)] action in Button widget.
  ApiCallResponse? representantes;

  @override
  void initState(BuildContext context) {}

  @override
  void dispose() {
    txtCpfFocusNode?.dispose();
    txtCpfTextController?.dispose();

    txtDataNascFocusNode?.dispose();
    txtDataNascTextController?.dispose();
  }
}
