import '/backend/api_requests/api_calls.dart';
import '/backend/schema/structs/index.dart';
import '/components/pagamento_listar_item_widget.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'boletos_widget.dart' show BoletosWidget;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';

class BoletosModel extends FlutterFlowModel<BoletosWidget> {
  ///  State fields for stateful widgets in this page.

  // Models for PagamentoListarItem dynamic component.
  late FlutterFlowDynamicModels<PagamentoListarItemModel>
      pagamentoListarItemModels;

  @override
  void initState(BuildContext context) {
    pagamentoListarItemModels =
        FlutterFlowDynamicModels(() => PagamentoListarItemModel());
  }

  @override
  void dispose() {
    pagamentoListarItemModels.dispose();
  }
}
