import '/backend/api_requests/api_calls.dart';
import '/backend/schema/structs/index.dart';
import '/components/historico_solicitacoes_card_widget.dart';
import '/flutter_flow/flutter_flow_drop_down.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import '/flutter_flow/form_field_controller.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'historico_solicitacoes_widget.dart' show HistoricoSolicitacoesWidget;
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';

class HistoricoSolicitacoesModel
    extends FlutterFlowModel<HistoricoSolicitacoesWidget> {
  ///  State fields for stateful widgets in this page.

  // State field(s) for DropDownTipo widget.
  String? dropDownTipoValue;
  FormFieldController<String>? dropDownTipoValueController;
  // State field(s) for DropDownStatus widget.
  String? dropDownStatusValue;
  FormFieldController<String>? dropDownStatusValueController;
  // Models for HistoricoSolicitacoesCard dynamic component.
  late FlutterFlowDynamicModels<HistoricoSolicitacoesCardModel>
      historicoSolicitacoesCardModels;

  @override
  void initState(BuildContext context) {
    historicoSolicitacoesCardModels =
        FlutterFlowDynamicModels(() => HistoricoSolicitacoesCardModel());
  }

  @override
  void dispose() {
    historicoSolicitacoesCardModels.dispose();
  }
}
