import '/backend/api_requests/api_calls.dart';
import '/backend/schema/structs/index.dart';
import '/components/notificacoes_widget.dart';
import '/flutter_flow/flutter_flow_icon_button.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import '/flutter_flow/upload_data.dart';
import 'dart:ui';
import 'package:badges/badges.dart' as badges;
import 'pagina_titular_widget.dart' show PaginaTitularWidget;
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';

class PaginaTitularModel extends FlutterFlowModel<PaginaTitularWidget> {
  ///  Local state fields for this page.

  List<ContratoStruct> contratos = [];
  void addToContratos(ContratoStruct item) => contratos.add(item);
  void removeFromContratos(ContratoStruct item) => contratos.remove(item);
  void removeAtIndexFromContratos(int index) => contratos.removeAt(index);
  void insertAtIndexInContratos(int index, ContratoStruct item) =>
      contratos.insert(index, item);
  void updateContratosAtIndex(int index, Function(ContratoStruct) updateFn) =>
      contratos[index] = updateFn(contratos[index]);

  int? selecionado;

  ///  State fields for stateful widgets in this page.

  // Stores action output result for [Backend Call - API (ObterAvatarUsuario)] action in PaginaTitular widget.
  ApiCallResponse? getAvatarAPIResponse;
  // Stores action output result for [Backend Call - API (getNotificacoesUsuario)] action in PaginaTitular widget.
  ApiCallResponse? apiResultNotificacoes;
  // Stores action output result for [Backend Call - API (Consulta Planos Beneficiario Por CPF)] action in PaginaTitular widget.
  ApiCallResponse? apiResult400;
  // Stores action output result for [Backend Call - API (getNotificacoesUsuario)] action in ListView widget.
  ApiCallResponse? apiResultNotificacoesRefresh;
  bool isDataUploading = false;
  FFUploadedFile uploadedLocalFile =
      FFUploadedFile(bytes: Uint8List.fromList([]));

  // Stores action output result for [Backend Call - API (AvatarUsuario)] action in Container widget.
  ApiCallResponse? apiResultp9f;
  // Stores action output result for [Backend Call - API (ObterAvatarUsuario)] action in Container widget.
  ApiCallResponse? getAvatarAPIResponse1;

  @override
  void initState(BuildContext context) {}

  @override
  void dispose() {}
}
